import { aC as useStyleTag, s as useUIPermission, u as useNuxtApp, ap as useMetas, r as ref, i as inject, aD as IsPublicInj, f as computed, w as watch, aE as useSharedView, az as ReloadViewDataHookInj, aF as useProject, aG as NOCO, $ as message, a2 as extractSdkResponseErrorMsg, aH as h, U as UITypes, o as openBlock, c as createElementBlock, b as createBaseVNode, _ as _export_sfc, d as defineComponent, M as MetaInj, A as ActiveViewInj, F as FieldsInj, ac as IsLockedInj, y as resolveDirective, l as createBlock, k as withCtx, D as withModifiers, j as createVNode, J as withDirectives, aI as vShow, ad as resolveDynamicComponent, z as toDisplayString, B as createCommentVNode, E as createTextVNode, H as normalizeClass, K as Draggable, L as pushScopeId, N as popScopeId, aJ as MdiMenuDown, O as Button, W as Input, aK as Checkbox, aL as __unplugin_components_2, V as Dropdown, m as isVirtualCol, aM as __nuxt_component_0$1, aN as __nuxt_component_0$2, q as useGlobal, aO as useViewFilters, ax as watchEffect, aP as __nuxt_component_0$3, g as Fragment, h as renderList, aQ as FieldListAutoCompleteDropdown, aR as MdiDeleteIcon, T as MdiPlus, aS as SelectOption, aT as __unplugin_components_3, aU as useSmartsheetStoreOrThrow, aV as useClipboard, aW as useDashboard, a7 as ViewTypes, x as onMounted, ag as __unplugin_components_3$1, aX as __unplugin_components_8, aY as Collapse, aa as Modal, ah as __unplugin_components_7, aA as OpenNewRecordFormHookInj, aZ as __nuxt_component_0$4, P as PaginationDataInj, C as ChangePageInj, G as withKeys, a_ as __unplugin_components_5, aq as toRef, au as renderSlot, R as ReadonlyInj, t as reactive, p as provide, I as IsFormInj, e as IsGridInj, a$ as useEventListener, v as onClickOutside, b0 as createSlots, ae as normalizeStyle, b1 as enumColor, ai as __unplugin_components_0$5, am as Menu, b2 as NavigateDir } from "./entry-3ffd12c8.mjs";
import { _ as __unplugin_components_0$1, a as __unplugin_components_0$3 } from "./magnify-46b1e6c4.mjs";
import { i as isSystemColumn, f as extractPkFromRow, u as useProvideSmartsheetRowStore, a as __nuxt_component_0$5, b as __nuxt_component_1$2, e as __nuxt_component_2$1, M as MdiArrowExpand, c as __nuxt_component_0$6, d as __nuxt_component_1$3 } from "./Cell-c11652dd.mjs";
import { M as MdiOpenInNewIcon } from "./open-in-new-32a1445c.mjs";
import { _ as __unplugin_components_0$2 } from "./reload-d0c0d5ed.mjs";
import { _ as __unplugin_components_4 } from "./plus-outline-d4c7c0e9.mjs";
import { u as useSidebar } from "./index-75f7d1ec.mjs";
import { _ as __unplugin_components_0$4 } from "./menu-280c7cba.mjs";
import { _ as __unplugin_components_3$2, a as __nuxt_component_7$1 } from "./index-346f2515.mjs";
function useGridViewColumnWidth(view) {
  const { css, load: loadCss, unload: unloadCss } = useStyleTag("");
  const { isUIAllowed } = useUIPermission();
  const { $api } = useNuxtApp();
  const { metas } = useMetas();
  const gridViewCols = ref({});
  const resizingCol = ref("");
  const resizingColWidth = ref("200px");
  const isPublic = inject(IsPublicInj, ref(false));
  const columns = computed(() => {
    var _a, _b, _c;
    return (_c = (_b = metas == null ? void 0 : metas.value) == null ? void 0 : _b[(_a = view == null ? void 0 : view.value) == null ? void 0 : _a.fk_model_id]) == null ? void 0 : _c.columns;
  });
  watch([gridViewCols, resizingCol, resizingColWidth], () => {
    var _a, _b;
    let style = "";
    for (const c of (columns == null ? void 0 : columns.value) || []) {
      const val = ((_b = (_a = gridViewCols == null ? void 0 : gridViewCols.value) == null ? void 0 : _a[c == null ? void 0 : c.id]) == null ? void 0 : _b.width) || "200px";
      if (val && c.title !== (resizingCol == null ? void 0 : resizingCol.value)) {
        style += `[data-col="${c.id}"]{min-width:${val};max-width:${val};width: ${val};}`;
      } else {
        style += `[data-col="${c.id}"]{min-width:${resizingColWidth == null ? void 0 : resizingColWidth.value};max-width:${resizingColWidth == null ? void 0 : resizingColWidth.value};width: ${resizingColWidth == null ? void 0 : resizingColWidth.value};}`;
      }
    }
    css.value = style;
  }, { deep: true, immediate: true });
  const loadGridViewColumns = async () => {
    var _a;
    if (!((_a = view.value) == null ? void 0 : _a.id) && !isPublic.value)
      return;
    const colsData = isPublic.value ? columns.value : await $api.dbView.gridColumnsList(view.value.id);
    gridViewCols.value = colsData.reduce((o, col) => ({
      ...o,
      [col.fk_column_id]: col
    }), {});
    loadCss();
  };
  watch(columns, loadGridViewColumns);
  const updateWidth = (id, width) => {
    var _a, _b;
    if ((_a = gridViewCols == null ? void 0 : gridViewCols.value) == null ? void 0 : _a[id]) {
      gridViewCols.value[id].width = width;
    }
    if (!isPublic.value && isUIAllowed("gridColUpdate") && ((_b = gridViewCols.value[id]) == null ? void 0 : _b.id)) {
      $api.dbView.gridColumnUpdate(gridViewCols.value[id].id, {
        width
      });
    }
  };
  return { loadGridViewColumns, updateWidth, resizingCol, resizingColWidth, loadCss, unloadCss };
}
function useViewSorts(view, reloadData) {
  const _sorts = ref([]);
  const { sorts: sharedViewSorts, sharedView } = useSharedView();
  const reloadHook = inject(ReloadViewDataHookInj);
  const isPublic = inject(IsPublicInj, ref(false));
  const { isSharedBase } = useProject();
  const sorts = computed({
    get: () => isPublic.value || isSharedBase.value ? sharedViewSorts.value : _sorts.value,
    set: (value) => {
      if (isPublic.value || isSharedBase.value) {
        sharedViewSorts.value = value;
      } else {
        _sorts.value = value;
      }
      reloadHook == null ? void 0 : reloadHook.trigger();
    }
  });
  const { $api } = useNuxtApp();
  const { isUIAllowed } = useUIPermission();
  const loadSorts = async () => {
    var _a, _b, _c, _d;
    if (isPublic.value) {
      const sharedSorts = ((_a = sharedView.value) == null ? void 0 : _a.sorts) || [];
      sorts.value = [...sharedSorts];
      return;
    }
    if (!(view == null ? void 0 : view.value))
      return;
    sorts.value = (_d = (_c = await $api.dbTableSort.list((_b = view == null ? void 0 : view.value) == null ? void 0 : _b.id)) == null ? void 0 : _c.sorts) == null ? void 0 : _d.list;
  };
  const saveOrUpdate = async (sort, i) => {
    var _a;
    if (isPublic.value || isSharedBase.value) {
      sorts.value[i] = sort;
      sorts.value = [...sorts.value];
      return;
    }
    if (isUIAllowed("sortSync")) {
      if (sort.id) {
        await $api.dbTableSort.update(sort.id, sort);
      } else {
        sorts.value[i] = await $api.dbTableSort.create((_a = view == null ? void 0 : view.value) == null ? void 0 : _a.id, sort);
      }
    }
    reloadData == null ? void 0 : reloadData();
  };
  const addSort = () => {
    sorts.value = [
      ...sorts.value,
      {
        direction: "asc"
      }
    ];
  };
  const deleteSort = async (sort, i) => {
    if (isUIAllowed("sortSync") && sort.id && !isPublic.value && !isSharedBase.value) {
      await $api.dbTableSort.delete(sort.id);
    }
    sorts.value.splice(i, 1);
    sorts.value = [...sorts.value];
  };
  return { sorts, loadSorts, addSort, deleteSort, saveOrUpdate };
}
function useViewColumns(view, meta, reloadData) {
  const isPublic = inject(IsPublicInj, ref(false));
  const fields = ref();
  const filterQuery = ref("");
  const { $api } = useNuxtApp();
  const { isUIAllowed } = useUIPermission();
  const { isSharedBase } = useProject();
  const loadViewColumns = async () => {
    var _a, _b, _c, _d;
    if (!meta || !view)
      return;
    let order = 1;
    if ((_a = view.value) == null ? void 0 : _a.id) {
      const data = isPublic.value ? (_b = meta.value) == null ? void 0 : _b.columns : await $api.dbViewColumn.list(view.value.id);
      const fieldById = data.reduce((acc, curr) => {
        curr.show = !!curr.show;
        return {
          ...acc,
          [curr.fk_column_id]: curr
        };
      }, {});
      fields.value = (_d = (_c = meta.value) == null ? void 0 : _c.columns) == null ? void 0 : _d.map((column) => {
        const currentColumnField = fieldById[column.id] || {};
        return {
          title: column.title,
          fk_column_id: column.id,
          ...currentColumnField,
          order: currentColumnField.order || order++,
          system: isSystemColumn(currentColumnField.type || false)
        };
      }).sort((a, b) => a.order - b.order);
    }
  };
  const showAll = async (ignoreIds) => {
    var _a, _b;
    if (isPublic.value || isSharedBase) {
      fields.value = (_a = fields.value) == null ? void 0 : _a.map((field) => ({
        ...field,
        show: true
      }));
      reloadData == null ? void 0 : reloadData();
      return;
    }
    if ((_b = view == null ? void 0 : view.value) == null ? void 0 : _b.id) {
      if (ignoreIds) {
        await $api.dbView.showAllColumn(view.value.id, {
          ignoreIds
        });
      } else {
        await $api.dbView.showAllColumn(view.value.id);
      }
    }
    await loadViewColumns();
    reloadData == null ? void 0 : reloadData();
  };
  const hideAll = async (ignoreIds) => {
    var _a, _b;
    if (isPublic.value || isSharedBase) {
      fields.value = (_a = fields.value) == null ? void 0 : _a.map((field) => ({
        ...field,
        show: false
      }));
      reloadData == null ? void 0 : reloadData();
      return;
    }
    if ((_b = view == null ? void 0 : view.value) == null ? void 0 : _b.id) {
      if (ignoreIds) {
        await $api.dbView.hideAllColumn(view.value.id, {
          ignoreIds
        });
      } else {
        await $api.dbView.hideAllColumn(view.value.id);
      }
    }
    await loadViewColumns();
    reloadData == null ? void 0 : reloadData();
  };
  const saveOrUpdate = async (field, index) => {
    var _a, _b, _c, _d;
    if (isPublic.value && fields.value) {
      fields.value[index] = field;
      meta.value.columns = (_b = (_a = meta.value) == null ? void 0 : _a.columns) == null ? void 0 : _b.map((column) => {
        if (column.id === field.fk_column_id) {
          return {
            ...column,
            ...field
          };
        }
        return column;
      });
      reloadData == null ? void 0 : reloadData();
      return;
    }
    if (isUIAllowed("fieldsSync")) {
      if (field.id && ((_c = view == null ? void 0 : view.value) == null ? void 0 : _c.id)) {
        await $api.dbViewColumn.update(view.value.id, field.id, field);
      } else if ((_d = view == null ? void 0 : view.value) == null ? void 0 : _d.id) {
        if (fields.value)
          fields.value[index] = await $api.dbViewColumn.create(view.value.id, field);
      }
    }
    reloadData == null ? void 0 : reloadData();
  };
  const metaColumnById = computed(() => {
    var _a, _b, _c;
    if (!((_a = meta.value) == null ? void 0 : _a.columns))
      return {};
    return (_c = (_b = meta.value) == null ? void 0 : _b.columns) == null ? void 0 : _c.reduce((acc, curr) => ({
      ...acc,
      [curr.id]: curr
    }), {});
  });
  const showSystemFields = computed({
    get() {
      var _a;
      return ((_a = view == null ? void 0 : view.value) == null ? void 0 : _a.show_system_fields) || false;
    },
    set(v) {
      var _a;
      if ((_a = view == null ? void 0 : view.value) == null ? void 0 : _a.id) {
        if (!isPublic.value && !isSharedBase) {
          $api.dbView.update(view.value.id, {
            show_system_fields: v
          }).finally(() => reloadData == null ? void 0 : reloadData());
        }
        view.value.show_system_fields = v;
      }
    }
  });
  const filteredFieldList = computed(() => {
    var _a;
    return ((_a = fields.value) == null ? void 0 : _a.filter((field) => {
      var _a2;
      if (!showSystemFields.value && isSystemColumn((_a2 = metaColumnById == null ? void 0 : metaColumnById.value) == null ? void 0 : _a2[field.fk_column_id])) {
        return false;
      }
      if (filterQuery.value === "") {
        return true;
      } else {
        return field.title.toLowerCase().includes(filterQuery.value.toLowerCase());
      }
    })) || [];
  });
  const sortedAndFilteredFields = computed(() => {
    var _a, _b, _c;
    return ((_c = (_b = (_a = fields == null ? void 0 : fields.value) == null ? void 0 : _a.filter((field) => {
      var _a2, _b2, _c2;
      if (!showSystemFields.value && metaColumnById.value && ((_a2 = metaColumnById == null ? void 0 : metaColumnById.value) == null ? void 0 : _a2[field.fk_column_id]) && isSystemColumn((_b2 = metaColumnById.value) == null ? void 0 : _b2[field.fk_column_id])) {
        return false;
      }
      return field.show && ((_c2 = metaColumnById == null ? void 0 : metaColumnById.value) == null ? void 0 : _c2[field.fk_column_id]);
    })) == null ? void 0 : _b.sort((a, b) => a.order - b.order)) == null ? void 0 : _c.map((field) => {
      var _a2;
      return (_a2 = metaColumnById == null ? void 0 : metaColumnById.value) == null ? void 0 : _a2[field.fk_column_id];
    })) || [];
  });
  watch(meta, () => loadViewColumns());
  return {
    fields,
    loadViewColumns,
    filteredFieldList,
    filterQuery,
    showAll,
    hideAll,
    saveOrUpdate,
    sortedAndFilteredFields,
    showSystemFields,
    metaColumnById
  };
}
const formatData = (list) => list.map((row) => ({
  row: { ...row },
  oldRow: { ...row },
  rowMeta: {}
}));
function useViewData(meta, viewMeta, where) {
  if (!meta) {
    throw new Error("Table meta is not available");
  }
  const _paginationData = ref({ page: 1, pageSize: 25 });
  const aggCommentCount = ref([]);
  const galleryData = ref();
  const formColumnData = ref();
  const formViewData = ref();
  const formattedData = ref([]);
  const isPublic = inject(IsPublicInj, ref(false));
  const { project } = useProject();
  const { fetchSharedViewData, paginationData: sharedPaginationData } = useSharedView();
  const { $api } = useNuxtApp();
  const { sorts, nestedFilters: filters } = useSharedView();
  const { isUIAllowed } = useUIPermission();
  const paginationData = computed({
    get: () => isPublic.value ? sharedPaginationData.value : _paginationData.value,
    set: (value) => {
      if (isPublic.value) {
        sharedPaginationData.value = value;
      } else {
        _paginationData.value = value;
      }
    }
  });
  const selectedAllRecords = computed({
    get() {
      return !!formattedData.value.length && formattedData.value.every((row) => row.rowMeta.selected);
    },
    set(selected) {
      formattedData.value.forEach((row) => row.rowMeta.selected = selected);
    }
  });
  const syncCount = async () => {
    var _a, _b, _c;
    const { count } = await $api.dbViewRow.count(NOCO, (_a = project == null ? void 0 : project.value) == null ? void 0 : _a.title, (_b = meta == null ? void 0 : meta.value) == null ? void 0 : _b.id, (_c = viewMeta == null ? void 0 : viewMeta.value) == null ? void 0 : _c.id);
    paginationData.value.totalRows = count;
  };
  const queryParams = computed(() => {
    var _a, _b, _c, _d, _e;
    return {
      offset: ((_b = (_a = paginationData.value) == null ? void 0 : _a.page) != null ? _b : 0) - 1,
      limit: (_d = (_c = paginationData.value) == null ? void 0 : _c.pageSize) != null ? _d : 25,
      where: (_e = where == null ? void 0 : where.value) != null ? _e : ""
    };
  });
  const loadAggCommentsCount = async () => {
    var _a, _b, _c, _d, _e;
    if (isPublic.value)
      return;
    const ids = (_b = (_a = formattedData.value) == null ? void 0 : _a.filter(({ rowMeta: { new: isNew } }) => !isNew)) == null ? void 0 : _b.map(({ row }) => {
      var _a2;
      return extractPkFromRow(row, (_a2 = meta == null ? void 0 : meta.value) == null ? void 0 : _a2.columns);
    });
    if (!(ids == null ? void 0 : ids.length) || (ids == null ? void 0 : ids.some((id) => !id)))
      return;
    aggCommentCount.value = await $api.utils.commentCount({
      ids,
      fk_model_id: meta.value.id
    });
    for (const row of formattedData.value) {
      const id = extractPkFromRow(row.row, (_c = meta == null ? void 0 : meta.value) == null ? void 0 : _c.columns);
      row.rowMeta.commentCount = ((_e = (_d = aggCommentCount.value) == null ? void 0 : _d.find((c) => c.row_id === id)) == null ? void 0 : _e.count) || 0;
    }
  };
  const loadData = async (params = {}) => {
    var _a, _b, _c;
    if ((!((_a = project == null ? void 0 : project.value) == null ? void 0 : _a.id) || !((_b = meta == null ? void 0 : meta.value) == null ? void 0 : _b.id) || !((_c = viewMeta == null ? void 0 : viewMeta.value) == null ? void 0 : _c.id)) && !isPublic.value)
      return;
    const response = !isPublic.value ? await $api.dbViewRow.list("noco", project.value.id, meta.value.id, viewMeta.value.id, {
      ...params,
      ...isUIAllowed("sortSync") ? {} : { sortArrJson: JSON.stringify(sorts.value) },
      ...isUIAllowed("filterSync") ? {} : { filterArrJson: JSON.stringify(filters.value) },
      where: where == null ? void 0 : where.value
    }) : await fetchSharedViewData();
    formattedData.value = formatData(response.list);
    paginationData.value = response.pageInfo;
    await loadAggCommentsCount();
  };
  const loadGalleryData = async () => {
    var _a;
    if (!((_a = viewMeta == null ? void 0 : viewMeta.value) == null ? void 0 : _a.id))
      return;
    galleryData.value = await $api.dbView.galleryRead(viewMeta.value.id);
  };
  const insertRow = async (row, rowIndex = ((_a) => (_a = formattedData.value) == null ? void 0 : _a.length)()) => {
    var _a2, _b, _c, _d;
    try {
      const insertObj = (_b = (_a2 = meta == null ? void 0 : meta.value) == null ? void 0 : _a2.columns) == null ? void 0 : _b.reduce((o, col) => {
        if (!col.ai && (row == null ? void 0 : row[col.title]) !== null) {
          o[col.title] = row == null ? void 0 : row[col.title];
        }
        return o;
      }, {});
      const insertedData = await $api.dbViewRow.create(NOCO, project == null ? void 0 : project.value.id, meta == null ? void 0 : meta.value.id, (_c = viewMeta == null ? void 0 : viewMeta.value) == null ? void 0 : _c.id, insertObj);
      (_d = formattedData.value) == null ? void 0 : _d.splice(rowIndex != null ? rowIndex : 0, 1, {
        row: insertedData,
        rowMeta: {},
        oldRow: { ...insertedData }
      });
      await syncCount();
      return insertedData;
    } catch (error) {
      message.error(await extractSdkResponseErrorMsg(error));
    }
  };
  const updateRowProperty = async (row, property) => {
    var _a, _b, _c;
    try {
      const id = (_b = (_a = meta == null ? void 0 : meta.value) == null ? void 0 : _a.columns) == null ? void 0 : _b.filter((c) => c.pk).map((c) => row[c.title]).join("___");
      return await $api.dbViewRow.update(NOCO, project == null ? void 0 : project.value.id, meta == null ? void 0 : meta.value.id, (_c = viewMeta == null ? void 0 : viewMeta.value) == null ? void 0 : _c.id, id, {
        [property]: row[property]
      });
    } catch (e) {
      message.error(`Row update failed ${await extractSdkResponseErrorMsg(e)}`);
    }
  };
  const updateOrSaveRow = async (row, property) => {
    if (row.rowMeta.new) {
      await insertRow(row.row, formattedData.value.indexOf(row));
    } else {
      await updateRowProperty(row.row, property);
    }
  };
  const changePage = async (page) => {
    paginationData.value.page = page;
    await loadData({ offset: (page - 1) * (paginationData.value.pageSize || 25), where: where == null ? void 0 : where.value });
  };
  const addEmptyRow = (addAfter = formattedData.value.length) => {
    formattedData.value.splice(addAfter, 0, {
      row: {},
      oldRow: {},
      rowMeta: { new: true }
    });
    return formattedData.value[addAfter];
  };
  const removeLastEmptyRow = () => {
    const lastRow = formattedData.value[formattedData.value.length - 1];
    if (lastRow.rowMeta.new) {
      formattedData.value.pop();
    }
  };
  const deleteRowById = async (id) => {
    if (!id) {
      throw new Error("Delete not allowed for table which doesn't have primary Key");
    }
    const res = await $api.dbViewRow.delete("noco", project.value.id, meta == null ? void 0 : meta.value.id, viewMeta == null ? void 0 : viewMeta.value.id, id);
    if (res.message) {
      message.info(`Row delete failed: ${h("div", {
        innerHTML: `<div style="padding:10px 4px">Unable to delete row with ID ${id} because of the following:
              <br><br>${res.message.join("<br>")}<br><br>
              Clear the data first & try again</div>`
      })}`);
      return false;
    }
    return true;
  };
  const deleteRow = async (rowIndex) => {
    var _a, _b;
    try {
      const row = formattedData.value[rowIndex];
      if (!row.rowMeta.new) {
        const id = (_b = (_a = meta == null ? void 0 : meta.value) == null ? void 0 : _a.columns) == null ? void 0 : _b.filter((c) => c.pk).map((c) => row.row[c.title]).join("___");
        const deleted = await deleteRowById(id);
        if (!deleted) {
          return;
        }
      }
      formattedData.value.splice(rowIndex, 1);
      await syncCount();
    } catch (e) {
      message.error(`Failed to delete row: ${await extractSdkResponseErrorMsg(e)}`);
    }
  };
  const deleteSelectedRows = async () => {
    var _a, _b;
    let row = formattedData.value.length;
    while (row--) {
      try {
        const { row: rowObj, rowMeta } = formattedData.value[row];
        if (!rowMeta.selected) {
          continue;
        }
        if (!rowMeta.new) {
          const id = (_b = (_a = meta == null ? void 0 : meta.value) == null ? void 0 : _a.columns) == null ? void 0 : _b.filter((c) => c.pk).map((c) => rowObj[c.title]).join("___");
          const successfulDeletion = await deleteRowById(id);
          if (!successfulDeletion) {
            continue;
          }
        }
        formattedData.value.splice(row, 1);
      } catch (e) {
        return message.error(`Failed to delete row: ${await extractSdkResponseErrorMsg(e)}`);
      }
    }
    await syncCount();
  };
  const loadFormView = async () => {
    var _a, _b, _c;
    if (!((_a = viewMeta == null ? void 0 : viewMeta.value) == null ? void 0 : _a.id))
      return;
    try {
      const { columns, ...view } = await $api.dbView.formRead(viewMeta.value.id);
      const fieldById = columns.reduce((o, f) => ({
        ...o,
        [f.fk_column_id]: f
      }), {});
      let order = 1;
      formViewData.value = view;
      formColumnData.value = (_c = (_b = meta == null ? void 0 : meta.value) == null ? void 0 : _b.columns) == null ? void 0 : _c.map((c) => ({
        ...c,
        fk_column_id: c.id,
        fk_view_id: viewMeta.value.id,
        ...fieldById[c.id] ? fieldById[c.id] : {},
        order: fieldById[c.id] && fieldById[c.id].order || order++,
        id: fieldById[c.id] && fieldById[c.id].id
      })).sort((a, b) => a.order - b.order);
    } catch (e) {
      return message.error(`Failed to set form data: ${await extractSdkResponseErrorMsg(e)}`);
    }
  };
  const updateFormView = async (view) => {
    var _a;
    try {
      if (!((_a = viewMeta == null ? void 0 : viewMeta.value) == null ? void 0 : _a.id) || !view)
        return;
      await $api.dbView.formUpdate(viewMeta.value.id, view);
    } catch (e) {
      return message.error(`Failed to update form view: ${await extractSdkResponseErrorMsg(e)}`);
    }
  };
  return {
    loadData,
    paginationData,
    queryParams,
    formattedData,
    insertRow,
    updateRowProperty,
    changePage,
    addEmptyRow,
    deleteRow,
    deleteSelectedRows,
    updateOrSaveRow,
    selectedAllRecords,
    syncCount,
    galleryData,
    loadGalleryData,
    loadFormView,
    formColumnData,
    formViewData,
    updateFormView,
    aggCommentCount,
    loadAggCommentsCount,
    removeLastEmptyRow
  };
}
const getSortDirectionOptions = (uidt) => {
  switch (uidt) {
    case UITypes.Year:
    case UITypes.Number:
    case UITypes.Decimal:
    case UITypes.Rating:
    case UITypes.Count:
    case UITypes.AutoNumber:
    case UITypes.Time:
    case UITypes.Currency:
    case UITypes.Percent:
    case UITypes.Duration:
    case UITypes.PhoneNumber:
    case UITypes.Date:
    case UITypes.DateTime:
    case UITypes.CreateTime:
    case UITypes.LastModifiedTime:
      return [
        { text: "1 \u2192 9", value: "asc" },
        { text: "9 \u2192 1", value: "desc" }
      ];
    case UITypes.Checkbox:
      return [
        { text: "\u25A2 \u2192 \u2713", value: "asc" },
        { text: "\u2713 \u2192 \u25A2", value: "desc" }
      ];
    default:
      return [
        { text: "A \u2192 Z", value: "asc" },
        { text: "Z \u2192 A", value: "desc" }
      ];
  }
};
const _hoisted_1$b = {
  class: "nc-icon",
  preserveAspectRatio: "xMidYMid meet",
  viewBox: "0 0 24 24",
  width: "1.2em",
  height: "1.2em"
};
const _hoisted_2$9 = /* @__PURE__ */ createBaseVNode("path", {
  fill: "currentColor",
  d: "M2 5.27L3.28 4L20 20.72L18.73 22l-3.08-3.08c-1.15.38-2.37.58-3.65.58c-5 0-9.27-3.11-11-7.5c.69-1.76 1.79-3.31 3.19-4.54L2 5.27M12 9a3 3 0 0 1 3 3a3 3 0 0 1-.17 1L11 9.17A3 3 0 0 1 12 9m0-4.5c5 0 9.27 3.11 11 7.5a11.79 11.79 0 0 1-4 5.19l-1.42-1.43A9.862 9.862 0 0 0 20.82 12A9.821 9.821 0 0 0 12 6.5c-1.09 0-2.16.18-3.16.5L7.3 5.47c1.44-.62 3.03-.97 4.7-.97M3.18 12A9.821 9.821 0 0 0 12 17.5c.69 0 1.37-.07 2-.21L11.72 15A3.064 3.064 0 0 1 9 12.28L5.6 8.87c-.99.85-1.82 1.91-2.42 3.13Z"
}, null, -1);
const _hoisted_3$8 = [
  _hoisted_2$9
];
function render$2(_ctx, _cache) {
  return openBlock(), createElementBlock("svg", _hoisted_1$b, _hoisted_3$8);
}
var __unplugin_components_10 = { name: "mdi-eye-off-outline", render: render$2 };
const _sfc_main$b = /* @__PURE__ */ defineComponent({
  __name: "FieldsMenu",
  setup(__props, { expose }) {
    expose();
    const meta = inject(MetaInj);
    const activeView = inject(ActiveViewInj);
    const reloadDataHook = inject(ReloadViewDataHookInj);
    const rootFields = inject(FieldsInj);
    const isLocked = inject(IsLockedInj, ref(false));
    const isPublic = inject(IsPublicInj, ref(false));
    const { $e } = useNuxtApp();
    const {
      showSystemFields,
      sortedAndFilteredFields,
      fields,
      loadViewColumns,
      filteredFieldList,
      filterQuery,
      showAll,
      hideAll,
      saveOrUpdate,
      metaColumnById
    } = useViewColumns(activeView, meta, () => reloadDataHook.trigger());
    watch(() => {
      var _a;
      return (_a = activeView.value) == null ? void 0 : _a.id;
    }, async (newVal, oldVal) => {
      if (newVal !== oldVal && meta.value) {
        await loadViewColumns();
      }
    }, { immediate: true });
    watch(sortedAndFilteredFields, (v) => {
      if (rootFields)
        rootFields.value = v || [];
    }, { immediate: true });
    const isAnyFieldHidden = computed(() => {
      var _a;
      return (_a = fields.value) == null ? void 0 : _a.some((field) => !(!showSystemFields && field.system) && !field.show);
    });
    const onMove = (event) => {
      if (!fields.value)
        return;
      if (fields.value.length < 2)
        return;
      fields.value.map((field, index) => {
        field.order = index + 1;
        return field;
      });
      saveOrUpdate(fields.value[event.moved.newIndex], event.moved.newIndex);
      $e("a:fields:reorder");
    };
    const getIcon = (c) => h(isVirtualCol(c) ? __nuxt_component_0$1 : __nuxt_component_0$2, {
      columnMeta: c
    });
    const __returned__ = { meta, activeView, reloadDataHook, rootFields, isLocked, isPublic, $e, showSystemFields, sortedAndFilteredFields, fields, loadViewColumns, filteredFieldList, filterQuery, showAll, hideAll, saveOrUpdate, metaColumnById, isAnyFieldHidden, onMove, getIcon, Draggable };
    Object.defineProperty(__returned__, "__isScriptSetup", { enumerable: false, value: true });
    return __returned__;
  }
});
const _withScopeId$3 = (n) => (pushScopeId("data-v-619007c2"), n = n(), popScopeId(), n);
const _hoisted_1$a = { class: "flex items-center gap-1" };
const _hoisted_2$8 = { class: "text-capitalize !text-sm font-weight-normal" };
const _hoisted_3$7 = { class: "nc-fields-list py-1" };
const _hoisted_4$5 = { class: "flex items-center" };
const _hoisted_5$4 = /* @__PURE__ */ _withScopeId$3(() => /* @__PURE__ */ createBaseVNode("div", { class: "flex-1" }, null, -1));
const _hoisted_6$3 = { class: "text-xs" };
function _sfc_render$b(_ctx, _cache, $props, $setup, $data, $options) {
  const _component_MdiEyeOffOutline = __unplugin_components_10;
  const _component_MdiMenuDown = MdiMenuDown;
  const _component_a_button = Button;
  const _component_a_input = Input;
  const _component_a_checkbox = Checkbox;
  const _component_MdiDrag = __unplugin_components_0$1;
  const _component_a_divider = __unplugin_components_2;
  const _component_a_dropdown = Dropdown;
  const _directive_t = resolveDirective("t");
  return openBlock(), createBlock(_component_a_dropdown, { trigger: ["click"] }, {
    overlay: withCtx(() => [
      createBaseVNode("div", {
        class: "p-3 min-w-[280px] bg-gray-50 shadow-lg nc-table-toolbar-menu max-h-[max(80vh,500px)] overflow-auto !border",
        onClick: _cache[10] || (_cache[10] = withModifiers(() => {
        }, ["stop"]))
      }, [
        createBaseVNode("div", {
          class: "p-1",
          onClick: _cache[1] || (_cache[1] = withModifiers(() => {
          }, ["stop"]))
        }, [
          createVNode(_component_a_input, {
            value: $setup.filterQuery,
            "onUpdate:value": _cache[0] || (_cache[0] = ($event) => $setup.filterQuery = $event),
            size: "small",
            placeholder: _ctx.$t("placeholder.searchFields")
          }, null, 8, ["value", "placeholder"])
        ]),
        createBaseVNode("div", _hoisted_3$7, [
          createVNode($setup["Draggable"], {
            modelValue: $setup.fields,
            "onUpdate:modelValue": _cache[3] || (_cache[3] = ($event) => $setup.fields = $event),
            "item-key": "id",
            onChange: _cache[4] || (_cache[4] = ($event) => $setup.onMove($event))
          }, {
            item: withCtx(({ element: field, index }) => [
              withDirectives((openBlock(), createElementBlock("div", {
                key: field.id,
                class: "px-2 py-1 flex items-center",
                onClick: _cache[2] || (_cache[2] = withModifiers(() => {
                }, ["stop"]))
              }, [
                createVNode(_component_a_checkbox, {
                  checked: field.show,
                  "onUpdate:checked": ($event) => field.show = $event,
                  class: "shrink",
                  onChange: ($event) => $setup.saveOrUpdate(field, index)
                }, {
                  default: withCtx(() => [
                    createBaseVNode("div", _hoisted_4$5, [
                      (openBlock(), createBlock(resolveDynamicComponent($setup.getIcon($setup.metaColumnById[field.fk_column_id])))),
                      createBaseVNode("span", null, toDisplayString(field.title), 1)
                    ])
                  ]),
                  _: 2
                }, 1032, ["checked", "onUpdate:checked", "onChange"]),
                _hoisted_5$4,
                createVNode(_component_MdiDrag, { class: "cursor-move" })
              ])), [
                [vShow, $setup.filteredFieldList.includes(field)]
              ])
            ]),
            _: 1
          }, 8, ["modelValue"])
        ]),
        createVNode(_component_a_divider, { class: "!my-2" }),
        !$setup.isPublic ? (openBlock(), createElementBlock("div", {
          key: 0,
          class: "p-2 py-1 flex",
          onClick: _cache[6] || (_cache[6] = withModifiers(() => {
          }, ["stop"]))
        }, [
          createVNode(_component_a_checkbox, {
            checked: $setup.showSystemFields,
            "onUpdate:checked": _cache[5] || (_cache[5] = ($event) => $setup.showSystemFields = $event)
          }, {
            default: withCtx(() => [
              createBaseVNode("span", _hoisted_6$3, toDisplayString(_ctx.$t("activity.showSystemFields")), 1)
            ]),
            _: 1
          }, 8, ["checked"])
        ])) : createCommentVNode("", true),
        createBaseVNode("div", {
          class: "p-2 flex gap-2",
          onClick: _cache[9] || (_cache[9] = withModifiers(() => {
          }, ["stop"]))
        }, [
          createVNode(_component_a_button, {
            size: "small",
            class: "!text-xs text-gray-500 text-capitalize",
            onClick: _cache[7] || (_cache[7] = withModifiers(($event) => $setup.showAll(), ["stop"]))
          }, {
            default: withCtx(() => [
              createTextVNode(toDisplayString(_ctx.$t("general.showAll")), 1)
            ]),
            _: 1
          }),
          createVNode(_component_a_button, {
            size: "small",
            class: "!text-xs text-gray-500 text-capitalize",
            onClick: _cache[8] || (_cache[8] = withModifiers(($event) => $setup.hideAll(), ["stop"]))
          }, {
            default: withCtx(() => [
              createTextVNode(toDisplayString(_ctx.$t("general.hideAll")), 1)
            ]),
            _: 1
          })
        ])
      ])
    ]),
    default: withCtx(() => [
      createBaseVNode("div", {
        class: normalizeClass({ "nc-badge nc-active-btn": $setup.isAnyFieldHidden })
      }, [
        withDirectives((openBlock(), createBlock(_component_a_button, {
          class: "nc-fields-menu-btn nc-toolbar-btn",
          disabled: $setup.isLocked
        }, {
          default: withCtx(() => [
            createBaseVNode("div", _hoisted_1$a, [
              createVNode(_component_MdiEyeOffOutline),
              createBaseVNode("span", _hoisted_2$8, toDisplayString(_ctx.$t("objects.fields")), 1),
              createVNode(_component_MdiMenuDown, { class: "text-grey" })
            ])
          ]),
          _: 1
        }, 8, ["disabled"])), [
          [_directive_t, ["c:fields"]]
        ])
      ], 2)
    ]),
    _: 1
  });
}
var __nuxt_component_1$1 = /* @__PURE__ */ _export_sfc(_sfc_main$b, [["render", _sfc_render$b], ["__scopeId", "data-v-619007c2"]]);
const _hoisted_1$9 = {
  class: "nc-icon",
  preserveAspectRatio: "xMidYMid meet",
  viewBox: "0 0 24 24",
  width: "1.2em",
  height: "1.2em"
};
const _hoisted_2$7 = /* @__PURE__ */ createBaseVNode("path", {
  fill: "currentColor",
  d: "M15 19.88c.04.3-.06.62-.29.83a.996.996 0 0 1-1.41 0L9.29 16.7a.989.989 0 0 1-.29-.83v-5.12L4.21 4.62a1 1 0 0 1 .17-1.4c.19-.14.4-.22.62-.22h14c.22 0 .43.08.62.22a1 1 0 0 1 .17 1.4L15 10.75v9.13M7.04 5L11 10.06v5.52l2 2v-7.53L16.96 5H7.04Z"
}, null, -1);
const _hoisted_3$6 = [
  _hoisted_2$7
];
function render$1(_ctx, _cache) {
  return openBlock(), createElementBlock("svg", _hoisted_1$9, _hoisted_3$6);
}
var __unplugin_components_0 = { name: "mdi-filter-outline", render: render$1 };
const _sfc_main$a = /* @__PURE__ */ defineComponent({
  __name: "ColumnFilterMenu",
  setup(__props, { expose }) {
    expose();
    const isLocked = inject(IsLockedInj, ref(false));
    const activeView = inject(ActiveViewInj);
    const isPublic = inject(IsPublicInj, ref(false));
    const { filterAutoSave } = useGlobal();
    const filterComp = ref();
    const { filters, loadFilters } = useViewFilters(activeView, void 0, computed(() => false));
    const filtersLength = ref(0);
    watchEffect(async () => {
      if (activeView == null ? void 0 : activeView.value) {
        await loadFilters();
        filtersLength.value = filters.value.length || 0;
      }
    });
    const applyChanges = async () => {
      var _a;
      return await ((_a = filterComp.value) == null ? void 0 : _a.applyChanges());
    };
    const __returned__ = { isLocked, activeView, isPublic, filterAutoSave, filterComp, filters, loadFilters, filtersLength, applyChanges };
    Object.defineProperty(__returned__, "__isScriptSetup", { enumerable: false, value: true });
    return __returned__;
  }
});
const _hoisted_1$8 = { class: "flex items-center gap-1" };
const _hoisted_2$6 = { class: "text-capitalize !text-sm font-weight-normal" };
const _hoisted_3$5 = { class: "text-grey text-xs" };
const _hoisted_4$4 = /* @__PURE__ */ createBaseVNode("div", { class: "flex-1" }, null, -1);
const _hoisted_5$3 = /* @__PURE__ */ createTextVNode(" Apply changes ");
function _sfc_render$a(_ctx, _cache, $props, $setup, $data, $options) {
  const _component_MdiFilterOutline = __unplugin_components_0;
  const _component_MdiMenuDown = MdiMenuDown;
  const _component_a_button = Button;
  const _component_a_checkbox = Checkbox;
  const _component_SmartsheetToolbarColumnFilter = __nuxt_component_0$3;
  const _component_a_dropdown = Dropdown;
  const _directive_t = resolveDirective("t");
  return openBlock(), createBlock(_component_a_dropdown, { trigger: ["click"] }, {
    overlay: withCtx(() => [
      createVNode(_component_SmartsheetToolbarColumnFilter, {
        ref: "filterComp",
        class: "nc-table-toolbar-menu shadow-lg",
        "auto-save": $setup.filterAutoSave,
        "onUpdate:filtersLength": _cache[2] || (_cache[2] = ($event) => $setup.filtersLength = $event)
      }, {
        default: withCtx(() => [
          !$setup.isPublic ? (openBlock(), createElementBlock("div", {
            key: 0,
            class: "flex items-end mt-2 min-h-[30px]",
            onClick: _cache[1] || (_cache[1] = withModifiers(() => {
            }, ["stop"]))
          }, [
            createVNode(_component_a_checkbox, {
              id: "col-filter-checkbox",
              checked: $setup.filterAutoSave,
              "onUpdate:checked": _cache[0] || (_cache[0] = ($event) => $setup.filterAutoSave = $event),
              class: "col-filter-checkbox",
              "hide-details": "",
              dense: ""
            }, {
              default: withCtx(() => [
                createBaseVNode("span", _hoisted_3$5, toDisplayString(_ctx.$t("msg.info.filterAutoApply")), 1)
              ]),
              _: 1
            }, 8, ["checked"]),
            _hoisted_4$4,
            withDirectives(createVNode(_component_a_button, {
              size: "small",
              class: "text-xs ml-2",
              onClick: $setup.applyChanges
            }, {
              default: withCtx(() => [
                _hoisted_5$3
              ]),
              _: 1
            }, 512), [
              [vShow, !$setup.filterAutoSave]
            ])
          ])) : createCommentVNode("", true)
        ]),
        _: 1
      }, 8, ["auto-save"])
    ]),
    default: withCtx(() => [
      createBaseVNode("div", {
        class: normalizeClass({ "nc-badge nc-active-btn": $setup.filtersLength })
      }, [
        withDirectives((openBlock(), createBlock(_component_a_button, {
          class: "nc-filter-menu-btn nc-toolbar-btn txt-sm",
          disabled: $setup.isLocked
        }, {
          default: withCtx(() => [
            createBaseVNode("div", _hoisted_1$8, [
              createVNode(_component_MdiFilterOutline),
              createBaseVNode("span", _hoisted_2$6, toDisplayString(_ctx.$t("activity.filter")), 1),
              createVNode(_component_MdiMenuDown, { class: "text-grey" })
            ])
          ]),
          _: 1
        }, 8, ["disabled"])), [
          [_directive_t, ["c:filter"]]
        ])
      ], 2)
    ]),
    _: 1
  });
}
var __nuxt_component_2 = /* @__PURE__ */ _export_sfc(_sfc_main$a, [["render", _sfc_render$a]]);
const _hoisted_1$7 = {
  class: "nc-icon",
  preserveAspectRatio: "xMidYMid meet",
  viewBox: "0 0 24 24",
  width: "1.2em",
  height: "1.2em"
};
const _hoisted_2$5 = /* @__PURE__ */ createBaseVNode("path", {
  fill: "currentColor",
  d: "m18 21l-4-4h3V7h-3l4-4l4 4h-3v10h3M2 19v-2h10v2M2 13v-2h7v2M2 7V5h4v2H2Z"
}, null, -1);
const _hoisted_3$4 = [
  _hoisted_2$5
];
function render(_ctx, _cache) {
  return openBlock(), createElementBlock("svg", _hoisted_1$7, _hoisted_3$4);
}
var MdiSortIcon = { name: "mdi-sort", render };
const _sfc_main$9 = /* @__PURE__ */ defineComponent({
  __name: "SortListMenu",
  setup(__props, { expose }) {
    expose();
    const meta = inject(MetaInj);
    const view = inject(ActiveViewInj);
    const isLocked = inject(IsLockedInj);
    const reloadDataHook = inject(ReloadViewDataHookInj);
    const { sorts, saveOrUpdate, loadSorts, addSort, deleteSort } = useViewSorts(view, () => reloadDataHook == null ? void 0 : reloadDataHook.trigger());
    const columns = computed(() => {
      var _a;
      return ((_a = meta == null ? void 0 : meta.value) == null ? void 0 : _a.columns) || [];
    });
    const columnByID = computed(() => {
      var _a;
      return (_a = columns == null ? void 0 : columns.value) == null ? void 0 : _a.reduce((obj, col) => {
        obj[col.id] = col;
        return obj;
      }, {});
    });
    watch(() => {
      var _a;
      return (_a = view == null ? void 0 : view.value) == null ? void 0 : _a.id;
    }, () => {
      loadSorts();
    }, { immediate: true });
    const __returned__ = { meta, view, isLocked, reloadDataHook, sorts, saveOrUpdate, loadSorts, addSort, deleteSort, columns, columnByID, FieldListAutoCompleteDropdown, getSortDirectionOptions, MdiMenuDownIcon: MdiMenuDown, MdiSortIcon, MdiDeleteIcon, MdiAddIcon: MdiPlus };
    Object.defineProperty(__returned__, "__isScriptSetup", { enumerable: false, value: true });
    return __returned__;
  }
});
const _hoisted_1$6 = { class: "flex items-center gap-1" };
const _hoisted_2$4 = { class: "text-capitalize !text-sm font-weight-normal" };
const _hoisted_3$3 = { class: "bg-gray-50 p-6 shadow-lg menu-filter-dropdown min-w-[400px] max-h-[max(80vh,500px)] overflow-auto !border" };
const _hoisted_4$3 = { class: "flex gap-1 items-center" };
function _sfc_render$9(_ctx, _cache, $props, $setup, $data, $options) {
  const _component_a_button = Button;
  const _component_a_select_option = SelectOption;
  const _component_a_select = __unplugin_components_3;
  const _component_a_dropdown = Dropdown;
  const _directive_t = resolveDirective("t");
  return openBlock(), createBlock(_component_a_dropdown, {
    "offset-y": "",
    class: "",
    trigger: ["click"]
  }, {
    overlay: withCtx(() => {
      var _a;
      return [
        createBaseVNode("div", _hoisted_3$3, [
          ((_a = $setup.sorts) == null ? void 0 : _a.length) ? (openBlock(), createElementBlock("div", {
            key: 0,
            class: "sort-grid mb-2",
            onClick: _cache[2] || (_cache[2] = withModifiers(() => {
            }, ["stop"]))
          }, [
            (openBlock(true), createElementBlock(Fragment, null, renderList($setup.sorts || [], (sort, i) => {
              return openBlock(), createElementBlock(Fragment, { key: i }, [
                createVNode($setup["MdiDeleteIcon"], {
                  class: "nc-sort-item-remove-btn text-grey self-center",
                  small: "",
                  onClick: withModifiers(($event) => $setup.deleteSort(sort, i), ["stop"])
                }, null, 8, ["onClick"]),
                createVNode($setup["FieldListAutoCompleteDropdown"], {
                  modelValue: sort.fk_column_id,
                  "onUpdate:modelValue": [($event) => sort.fk_column_id = $event, ($event) => $setup.saveOrUpdate(sort, i)],
                  class: "caption nc-sort-field-select",
                  columns: $setup.columns,
                  "is-sort": "",
                  onClick: _cache[0] || (_cache[0] = withModifiers(() => {
                  }, ["stop"]))
                }, null, 8, ["modelValue", "onUpdate:modelValue", "columns"]),
                createVNode(_component_a_select, {
                  value: sort.direction,
                  "onUpdate:value": ($event) => sort.direction = $event,
                  class: "shrink grow-0 nc-sort-dir-select !text-xs",
                  label: _ctx.$t("labels.operation"),
                  onClick: _cache[1] || (_cache[1] = withModifiers(() => {
                  }, ["stop"])),
                  onSelect: ($event) => $setup.saveOrUpdate(sort, i)
                }, {
                  default: withCtx(() => {
                    var _a2;
                    return [
                      (openBlock(true), createElementBlock(Fragment, null, renderList($setup.getSortDirectionOptions((_a2 = $setup.columnByID[sort.fk_column_id]) == null ? void 0 : _a2.uidt), (option, j) => {
                        return openBlock(), createBlock(_component_a_select_option, {
                          key: j,
                          value: option.value
                        }, {
                          default: withCtx(() => [
                            createBaseVNode("span", null, toDisplayString(option.text), 1)
                          ]),
                          _: 2
                        }, 1032, ["value"]);
                      }), 128))
                    ];
                  }),
                  _: 2
                }, 1032, ["value", "onUpdate:value", "label", "onSelect"])
              ], 64);
            }), 128))
          ])) : createCommentVNode("", true),
          createVNode(_component_a_button, {
            class: "text-capitalize mb-1 mt-4",
            type: "primary",
            ghost: "",
            onClick: withModifiers($setup.addSort, ["stop"])
          }, {
            default: withCtx(() => [
              createBaseVNode("div", _hoisted_4$3, [
                createVNode($setup["MdiAddIcon"]),
                createTextVNode(toDisplayString(_ctx.$t("activity.addSort")), 1)
              ])
            ]),
            _: 1
          }, 8, ["onClick"])
        ])
      ];
    }),
    default: withCtx(() => {
      var _a;
      return [
        createBaseVNode("div", {
          class: normalizeClass({ "nc-badge nc-active-btn": (_a = $setup.sorts) == null ? void 0 : _a.length })
        }, [
          withDirectives((openBlock(), createBlock(_component_a_button, {
            class: "nc-sort-menu-btn nc-toolbar-btn",
            disabled: $setup.isLocked
          }, {
            default: withCtx(() => [
              createBaseVNode("div", _hoisted_1$6, [
                createVNode($setup["MdiSortIcon"]),
                createBaseVNode("span", _hoisted_2$4, toDisplayString(_ctx.$t("activity.sort")), 1),
                createVNode($setup["MdiMenuDownIcon"], { class: "text-grey" })
              ])
            ]),
            _: 1
          }, 8, ["disabled"])), [
            [_directive_t, ["c:sort"]]
          ])
        ], 2)
      ];
    }),
    _: 1
  });
}
var __nuxt_component_3 = /* @__PURE__ */ _export_sfc(_sfc_main$9, [["render", _sfc_render$9], ["__scopeId", "data-v-c81f8c16"]]);
const _sfc_main$8 = /* @__PURE__ */ defineComponent({
  __name: "ShareView",
  setup(__props, { expose }) {
    expose();
    const { view, $api } = useSmartsheetStoreOrThrow();
    const { copy } = useClipboard();
    const { $e } = useNuxtApp();
    const { dashboardUrl } = useDashboard();
    const { isUIAllowed } = useUIPermission();
    const { isSharedBase } = useProject();
    let showShareModel = ref(false);
    let passwordProtected = ref(false);
    const shared = ref();
    const allowCSVDownload = computed({
      get() {
        var _a, _b;
        return !!((_b = ((_a = shared.value) == null ? void 0 : _a.meta) && typeof shared.value.meta === "string" ? JSON.parse(shared.value.meta) : shared.value.meta) == null ? void 0 : _b.allowCSVDownload);
      },
      set(allow) {
        shared.value.meta = { allowCSVDownload: allow };
        saveAllowCSVDownload();
      }
    });
    const genShareLink = async () => {
      shared.value = await $api.dbViewShare.create(view.value.id);
      showShareModel.value = true;
    };
    const sharedViewUrl = computed(() => {
      if (!shared.value)
        return;
      let viewType;
      switch (shared.value.type) {
        case ViewTypes.FORM:
          viewType = "form";
          break;
        case ViewTypes.KANBAN:
          viewType = "kanban";
          break;
        default:
          viewType = "view";
      }
      return `${dashboardUrl == null ? void 0 : dashboardUrl.value}/nc/${viewType}/${shared.value.uuid}`;
    });
    async function saveAllowCSVDownload() {
      try {
        const meta = shared.value.meta && typeof shared.value.meta === "string" ? JSON.parse(shared.value.meta) : shared.value.meta;
        await $api.dbViewShare.update(shared.value.id, {
          meta
        });
        message.success("Successfully updated");
      } catch (e) {
        message.error(await extractSdkResponseErrorMsg(e));
      }
      if (allowCSVDownload == null ? void 0 : allowCSVDownload.value) {
        $e("a:view:share:enable-csv-download");
      } else {
        $e("a:view:share:disable-csv-download");
      }
    }
    const saveShareLinkPassword = async () => {
      try {
        await $api.dbViewShare.update(shared.value.id, {
          password: shared.value.password
        });
        message.success("Successfully updated");
      } catch (e) {
        message.error(await extractSdkResponseErrorMsg(e));
      }
      $e("a:view:share:enable-pwd");
    };
    const copyLink = () => {
      copy(sharedViewUrl == null ? void 0 : sharedViewUrl.value);
      message.success("Copied to clipboard");
    };
    watch(() => passwordProtected.value, (value) => {
      if (!value) {
        shared.value.password = "";
        saveShareLinkPassword();
      }
    });
    onMounted(() => {
      var _a, _b;
      if ((_b = (_a = shared.value) == null ? void 0 : _a.password) == null ? void 0 : _b.length)
        passwordProtected.value = true;
    });
    const __returned__ = { view, $api, copy, $e, dashboardUrl, isUIAllowed, isSharedBase, showShareModel, passwordProtected, shared, allowCSVDownload, genShareLink, sharedViewUrl, saveAllowCSVDownload, saveShareLinkPassword, copyLink, ViewTypes, MdiOpenInNewIcon, MdiCopyIcon: __unplugin_components_3$1 };
    Object.defineProperty(__returned__, "__isScriptSetup", { enumerable: false, value: true });
    return __returned__;
  }
});
const _hoisted_1$5 = { class: "!text-sm font-weight-normal" };
const _hoisted_2$3 = { class: "share-link-box nc-share-link-box bg-primary-50" };
const _hoisted_3$2 = { class: "flex-1 h-min text-xs" };
const _hoisted_4$2 = ["href"];
const _hoisted_5$2 = { class: "mb-2" };
const _hoisted_6$2 = {
  key: 0,
  class: "flex gap-2 mt-2 mb-4"
};
const _hoisted_7$1 = /* @__PURE__ */ createTextVNode("Allow Download ");
function _sfc_render$8(_ctx, _cache, $props, $setup, $data, $options) {
  const _component_a_button = Button;
  const _component_a_checkbox = Checkbox;
  const _component_a_input = Input;
  const _component_a_collapse_panel = __unplugin_components_8;
  const _component_a_collapse = Collapse;
  const _component_a_modal = Modal;
  const _directive_t = resolveDirective("t");
  return openBlock(), createElementBlock("div", null, [
    $setup.isUIAllowed("share-view") && !$setup.isSharedBase ? withDirectives((openBlock(), createBlock(_component_a_button, {
      key: 0,
      outlined: "",
      class: "nc-btn-share-view nc-toolbar-btn"
    }, {
      default: withCtx(() => [
        createBaseVNode("div", {
          class: "flex items-center gap-1",
          onClick: $setup.genShareLink
        }, [
          createVNode($setup["MdiOpenInNewIcon"]),
          createBaseVNode("span", _hoisted_1$5, toDisplayString(_ctx.$t("activity.shareView")), 1)
        ])
      ]),
      _: 1
    })), [
      [_directive_t, ["c:view:share"]]
    ]) : createCommentVNode("", true),
    createVNode(_component_a_modal, {
      visible: $setup.showShareModel,
      "onUpdate:visible": _cache[3] || (_cache[3] = ($event) => $setup.showShareModel = $event),
      size: "small",
      title: _ctx.$t("msg.info.privateLink"),
      footer: null,
      width: "min(100vw,640px)"
    }, {
      default: withCtx(() => [
        createBaseVNode("div", _hoisted_2$3, [
          createBaseVNode("div", _hoisted_3$2, toDisplayString($setup.sharedViewUrl), 1),
          withDirectives((openBlock(), createElementBlock("a", {
            href: $setup.sharedViewUrl,
            target: "_blank"
          }, [
            createVNode($setup["MdiOpenInNewIcon"], { class: "text-sm text-gray-500 mt-2" })
          ], 8, _hoisted_4$2)), [
            [_directive_t, ["c:view:share:open-url"]]
          ]),
          createVNode($setup["MdiCopyIcon"], {
            class: "text-gray-500 text-sm cursor-pointer",
            onClick: $setup.copyLink
          })
        ]),
        createVNode(_component_a_collapse, { ghost: "" }, {
          default: withCtx(() => [
            createVNode(_component_a_collapse_panel, {
              key: "1",
              header: "More Options"
            }, {
              default: withCtx(() => [
                createBaseVNode("div", _hoisted_5$2, [
                  createVNode(_component_a_checkbox, {
                    checked: $setup.passwordProtected,
                    "onUpdate:checked": _cache[0] || (_cache[0] = ($event) => $setup.passwordProtected = $event),
                    class: "!text-xs"
                  }, {
                    default: withCtx(() => [
                      createTextVNode(toDisplayString(_ctx.$t("msg.info.beforeEnablePwd")), 1)
                    ]),
                    _: 1
                  }, 8, ["checked"]),
                  $setup.passwordProtected ? (openBlock(), createElementBlock("div", _hoisted_6$2, [
                    createVNode(_component_a_input, {
                      value: $setup.shared.password,
                      "onUpdate:value": _cache[1] || (_cache[1] = ($event) => $setup.shared.password = $event),
                      size: "small",
                      class: "!text-xs max-w-[250px]",
                      type: "password",
                      placeholder: _ctx.$t("placeholder.password.enter")
                    }, null, 8, ["value", "placeholder"]),
                    createVNode(_component_a_button, {
                      size: "small",
                      class: "!text-xs",
                      onClick: $setup.saveShareLinkPassword
                    }, {
                      default: withCtx(() => [
                        createTextVNode(toDisplayString(_ctx.$t("placeholder.password.save")), 1)
                      ]),
                      _: 1
                    })
                  ])) : createCommentVNode("", true)
                ]),
                createBaseVNode("div", null, [
                  $setup.shared && $setup.shared.type === $setup.ViewTypes.GRID ? (openBlock(), createBlock(_component_a_checkbox, {
                    key: 0,
                    checked: $setup.allowCSVDownload,
                    "onUpdate:checked": _cache[2] || (_cache[2] = ($event) => $setup.allowCSVDownload = $event),
                    class: "!text-xs"
                  }, {
                    default: withCtx(() => [
                      _hoisted_7$1
                    ]),
                    _: 1
                  }, 8, ["checked"])) : createCommentVNode("", true)
                ])
              ]),
              _: 1
            })
          ]),
          _: 1
        })
      ]),
      _: 1
    }, 8, ["visible", "title"])
  ]);
}
var __nuxt_component_4 = /* @__PURE__ */ _export_sfc(_sfc_main$8, [["render", _sfc_render$8], ["__scopeId", "data-v-3923e928"]]);
const _sfc_main$7 = /* @__PURE__ */ defineComponent({
  __name: "Reload",
  setup(__props, { expose }) {
    expose();
    const reloadHook = inject(ReloadViewDataHookInj);
    const onClick = () => reloadHook.trigger();
    const __returned__ = { reloadHook, onClick };
    Object.defineProperty(__returned__, "__isScriptSetup", { enumerable: false, value: true });
    return __returned__;
  }
});
const _hoisted_1$4 = { class: "group flex align-center" };
function _sfc_render$7(_ctx, _cache, $props, $setup, $data, $options) {
  const _component_MdiReload = __unplugin_components_0$2;
  const _component_a_tooltip = __unplugin_components_7;
  return openBlock(), createBlock(_component_a_tooltip, { placement: "bottom" }, {
    title: withCtx(() => [
      createTextVNode(toDisplayString(_ctx.$t("general.reload")), 1)
    ]),
    default: withCtx(() => [
      createBaseVNode("div", _hoisted_1$4, [
        createVNode(_component_MdiReload, {
          class: "cursor-pointer text-gray-500 group-hover:text-primary",
          onClick: $setup.onClick
        })
      ])
    ]),
    _: 1
  });
}
var __nuxt_component_5$1 = /* @__PURE__ */ _export_sfc(_sfc_main$7, [["render", _sfc_render$7]]);
const _sfc_main$6 = /* @__PURE__ */ defineComponent({
  __name: "AddRow",
  setup(__props, { expose }) {
    expose();
    const isLocked = inject(IsLockedInj);
    const openNewRecordFormHook = inject(OpenNewRecordFormHookInj);
    const onClick = () => {
      if (!(isLocked == null ? void 0 : isLocked.value))
        openNewRecordFormHook.trigger();
    };
    const __returned__ = { isLocked, openNewRecordFormHook, onClick };
    Object.defineProperty(__returned__, "__isScriptSetup", { enumerable: false, value: true });
    return __returned__;
  }
});
function _sfc_render$6(_ctx, _cache, $props, $setup, $data, $options) {
  const _component_MdiPlusOutline = __unplugin_components_4;
  const _component_a_tooltip = __unplugin_components_7;
  return openBlock(), createBlock(_component_a_tooltip, { placement: "bottom" }, {
    title: withCtx(() => [
      createTextVNode(toDisplayString(_ctx.$t("activity.addRow")), 1)
    ]),
    default: withCtx(() => [
      createBaseVNode("div", {
        class: normalizeClass([{ "group": !$setup.isLocked, "disabled-ring": $setup.isLocked }, "nc-add-row flex align-center"])
      }, [
        createVNode(_component_MdiPlusOutline, {
          class: normalizeClass({ "cursor-pointer text-gray-500 group-hover:text-primary": !$setup.isLocked, "disabled": $setup.isLocked }),
          onClick: $setup.onClick
        }, null, 8, ["class"])
      ], 2)
    ]),
    _: 1
  });
}
var __nuxt_component_6$1 = /* @__PURE__ */ _export_sfc(_sfc_main$6, [["render", _sfc_render$6]]);
const _sfc_main$5 = /* @__PURE__ */ defineComponent({
  __name: "SearchData",
  setup(__props, { expose }) {
    expose();
    const reloadData = inject(ReloadViewDataHookInj);
    const { search, meta } = useSmartsheetStoreOrThrow();
    const isDropdownOpen = ref(false);
    const columns = computed(() => {
      var _a, _b;
      return (_b = (_a = meta.value) == null ? void 0 : _a.columns) == null ? void 0 : _b.map((c) => ({
        value: c.id,
        label: c.title
      }));
    });
    function onPressEnter() {
      reloadData.trigger();
    }
    const __returned__ = { reloadData, search, meta, isDropdownOpen, columns, onPressEnter };
    Object.defineProperty(__returned__, "__isScriptSetup", { enumerable: false, value: true });
    return __returned__;
  }
});
function _sfc_render$5(_ctx, _cache, $props, $setup, $data, $options) {
  const _component_MdiMagnify = __unplugin_components_0$3;
  const _component_MdiMenuDown = MdiMenuDown;
  const _component_a_select = __unplugin_components_3;
  const _component_a_input = Input;
  return openBlock(), createBlock(_component_a_input, {
    value: $setup.search.query,
    "onUpdate:value": _cache[2] || (_cache[2] = ($event) => $setup.search.query = $event),
    size: "small",
    class: "max-w-[200px]",
    placeholder: "Filter query",
    onPressEnter: $setup.onPressEnter
  }, {
    addonBefore: withCtx(() => [
      createBaseVNode("div", {
        class: "flex items-center relative",
        onClick: _cache[1] || (_cache[1] = ($event) => $setup.isDropdownOpen = true)
      }, [
        createVNode(_component_MdiMagnify, { class: "text-grey" }),
        createVNode(_component_MdiMenuDown, { class: "text-grey" }),
        createVNode(_component_a_select, {
          value: $setup.search.field,
          "onUpdate:value": _cache[0] || (_cache[0] = ($event) => $setup.search.field = $event),
          size: "small",
          "dropdown-match-select-width": false,
          options: $setup.columns,
          class: "!absolute top-0 left-0 w-full h-full z-10 !text-xs opacity-0"
        }, null, 8, ["value", "options"])
      ])
    ]),
    _: 1
  }, 8, ["value"]);
}
var __nuxt_component_7 = /* @__PURE__ */ _export_sfc(_sfc_main$5, [["render", _sfc_render$5]]);
const _sfc_main$4 = /* @__PURE__ */ defineComponent({
  __name: "ToggleDrawer",
  setup(__props, { expose }) {
    expose();
    const { isOpen, toggle } = useSidebar({ storageKey: "nc-right-sidebar" });
    const __returned__ = { isOpen, toggle };
    Object.defineProperty(__returned__, "__isScriptSetup", { enumerable: false, value: true });
    return __returned__;
  }
});
const _hoisted_1$3 = /* @__PURE__ */ createTextVNode(" Views ");
function _sfc_render$4(_ctx, _cache, $props, $setup, $data, $options) {
  const _component_MdiMenu = __unplugin_components_0$4;
  const _component_a_button = Button;
  return openBlock(), createElementBlock("div", {
    class: normalizeClass({ "nc-active-btn": $setup.isOpen })
  }, [
    createVNode(_component_a_button, {
      size: "small",
      onClick: _cache[0] || (_cache[0] = ($event) => $setup.toggle(!$setup.isOpen))
    }, {
      default: withCtx(() => [
        createBaseVNode("div", {
          class: normalizeClass(["flex items-center gap-1 text-xs", { "text-gray-500": !$setup.isOpen }])
        }, [
          createVNode(_component_MdiMenu, { class: "!text-xs" }),
          _hoisted_1$3
        ], 2)
      ]),
      _: 1
    })
  ], 2);
}
var ToggleDrawer = /* @__PURE__ */ _export_sfc(_sfc_main$4, [["render", _sfc_render$4]]);
const _sfc_main$3 = /* @__PURE__ */ defineComponent({
  __name: "Toolbar",
  setup(__props, { expose }) {
    expose();
    const { isGrid, isForm, isGallery } = useSmartsheetStoreOrThrow();
    const isPublic = inject(IsPublicInj, ref(false));
    const { allowCSVDownload } = useSharedView();
    const { isOpen } = useSidebar();
    const __returned__ = { isGrid, isForm, isGallery, isPublic, allowCSVDownload, isOpen, ToggleDrawer };
    Object.defineProperty(__returned__, "__isScriptSetup", { enumerable: false, value: true });
    return __returned__;
  }
});
const _withScopeId$2 = (n) => (pushScopeId("data-v-3503251e"), n = n(), popScopeId(), n);
const _hoisted_1$2 = {
  class: "nc-table-toolbar w-full py-1 flex gap-1 items-center h-[var(--toolbar-height)] px-2 border-b overflow-x-hidden",
  style: { "z-index": "7" }
};
const _hoisted_2$2 = /* @__PURE__ */ _withScopeId$2(() => /* @__PURE__ */ createBaseVNode("div", { class: "flex-1" }, null, -1));
function _sfc_render$3(_ctx, _cache, $props, $setup, $data, $options) {
  const _component_SmartsheetToolbarViewActions = __nuxt_component_0$4;
  const _component_SmartsheetToolbarFieldsMenu = __nuxt_component_1$1;
  const _component_SmartsheetToolbarColumnFilterMenu = __nuxt_component_2;
  const _component_SmartsheetToolbarSortListMenu = __nuxt_component_3;
  const _component_SmartsheetToolbarShareView = __nuxt_component_4;
  const _component_SmartsheetToolbarReload = __nuxt_component_5$1;
  const _component_SmartsheetToolbarAddRow = __nuxt_component_6$1;
  const _component_SmartsheetToolbarSearchData = __nuxt_component_7;
  return openBlock(), createElementBlock("div", _hoisted_1$2, [
    $setup.isGrid && !$setup.isPublic || $setup.isGrid && $setup.isPublic && $setup.allowCSVDownload ? (openBlock(), createBlock(_component_SmartsheetToolbarViewActions, {
      key: 0,
      "show-system-fields": false,
      class: "ml-1"
    })) : createCommentVNode("", true),
    $setup.isGrid || $setup.isGallery ? (openBlock(), createBlock(_component_SmartsheetToolbarFieldsMenu, {
      key: 1,
      "show-system-fields": false,
      class: "ml-1"
    })) : createCommentVNode("", true),
    $setup.isGrid || $setup.isGallery ? (openBlock(), createBlock(_component_SmartsheetToolbarColumnFilterMenu, { key: 2 })) : createCommentVNode("", true),
    $setup.isGrid || $setup.isGallery ? (openBlock(), createBlock(_component_SmartsheetToolbarSortListMenu, { key: 3 })) : createCommentVNode("", true),
    ($setup.isForm || $setup.isGrid) && !$setup.isPublic ? (openBlock(), createBlock(_component_SmartsheetToolbarShareView, { key: 4 })) : createCommentVNode("", true),
    _hoisted_2$2,
    createVNode(_component_SmartsheetToolbarReload, { class: "mx-1" }),
    createVNode(_component_SmartsheetToolbarAddRow, { class: "mx-1" }),
    ($setup.isGrid || $setup.isGallery) && !$setup.isPublic ? (openBlock(), createBlock(_component_SmartsheetToolbarSearchData, {
      key: 5,
      class: "shrink mr-2 ml-2"
    })) : createCommentVNode("", true),
    !$setup.isOpen ? (openBlock(), createBlock($setup["ToggleDrawer"], {
      key: 6,
      class: "mr-2"
    })) : createCommentVNode("", true)
  ]);
}
var __nuxt_component_0 = /* @__PURE__ */ _export_sfc(_sfc_main$3, [["render", _sfc_render$3], ["__scopeId", "data-v-3503251e"]]);
const _sfc_main$2 = /* @__PURE__ */ defineComponent({
  __name: "Pagination",
  setup(__props, { expose }) {
    expose();
    const paginatedData = inject(PaginationDataInj);
    const changePage = inject(ChangePageInj);
    const count = computed(() => {
      var _a, _b;
      return (_b = (_a = paginatedData.value) == null ? void 0 : _a.totalRows) != null ? _b : Infinity;
    });
    const size = computed(() => {
      var _a, _b;
      return (_b = (_a = paginatedData.value) == null ? void 0 : _a.pageSize) != null ? _b : 25;
    });
    const page = computed({
      get: () => {
        var _a, _b;
        return (_b = (_a = paginatedData == null ? void 0 : paginatedData.value) == null ? void 0 : _a.page) != null ? _b : 1;
      },
      set: (p) => changePage == null ? void 0 : changePage(p)
    });
    const __returned__ = { paginatedData, changePage, count, size, page };
    Object.defineProperty(__returned__, "__isScriptSetup", { enumerable: false, value: true });
    return __returned__;
  }
});
const _withScopeId$1 = (n) => (pushScopeId("data-v-b0c03872"), n = n(), popScopeId(), n);
const _hoisted_1$1 = { class: "flex items-center mb-1" };
const _hoisted_2$1 = {
  key: 0,
  class: "caption ml-5 text-gray-500"
};
const _hoisted_3$1 = /* @__PURE__ */ _withScopeId$1(() => /* @__PURE__ */ createBaseVNode("div", { class: "flex-1" }, null, -1));
const _hoisted_4$1 = {
  key: 2,
  class: "mx-auto flex items-center mt-n1",
  style: { "max-width": "250px" }
};
const _hoisted_5$1 = /* @__PURE__ */ _withScopeId$1(() => /* @__PURE__ */ createBaseVNode("span", {
  class: "text-xs",
  style: { "white-space": "nowrap" }
}, " Change page:", -1));
const _hoisted_6$1 = /* @__PURE__ */ _withScopeId$1(() => /* @__PURE__ */ createBaseVNode("div", { class: "flex-1" }, null, -1));
function _sfc_render$2(_ctx, _cache, $props, $setup, $data, $options) {
  const _component_a_pagination = __unplugin_components_5;
  const _component_MdiKeyboardReturn = __unplugin_components_3$2;
  const _component_a_input = Input;
  return openBlock(), createElementBlock("div", _hoisted_1$1, [
    $setup.count !== null && $setup.count !== Infinity ? (openBlock(), createElementBlock("span", _hoisted_2$1, toDisplayString($setup.count) + " record" + toDisplayString($setup.count !== 1 ? "s" : ""), 1)) : createCommentVNode("", true),
    _hoisted_3$1,
    $setup.count !== Infinity ? (openBlock(), createBlock(_component_a_pagination, {
      key: 1,
      current: $setup.page,
      "onUpdate:current": _cache[0] || (_cache[0] = ($event) => $setup.page = $event),
      size: "small",
      class: "!text-xs !m-1 nc-pagination",
      total: $setup.count,
      "page-size": $setup.size,
      "show-less-items": "",
      "show-size-changer": false
    }, null, 8, ["current", "total", "page-size"])) : (openBlock(), createElementBlock("div", _hoisted_4$1, [
      _hoisted_5$1,
      createVNode(_component_a_input, {
        value: $setup.page,
        size: "small",
        class: "ml-1 !text-xs",
        type: "number",
        onKeydown: _cache[2] || (_cache[2] = withKeys(($event) => $setup.changePage($setup.page), ["enter"]))
      }, {
        suffix: withCtx(() => [
          createVNode(_component_MdiKeyboardReturn, {
            class: "mt-1",
            onClick: _cache[1] || (_cache[1] = ($event) => $setup.changePage($setup.page))
          })
        ]),
        _: 1
      }, 8, ["value"])
    ])),
    _hoisted_6$1
  ]);
}
var __nuxt_component_6 = /* @__PURE__ */ _export_sfc(_sfc_main$2, [["render", _sfc_render$2], ["__scopeId", "data-v-b0c03872"]]);
const _sfc_main$1 = /* @__PURE__ */ defineComponent({
  __name: "Row",
  props: {
    row: null
  },
  setup(__props, { expose }) {
    expose();
    const props = __props;
    const currentRow = toRef(props, "row");
    const { meta } = useSmartsheetStoreOrThrow();
    const { isNew, state, syncLTARRefs } = useProvideSmartsheetRowStore(meta, currentRow);
    watch(isNew, async (nextVal, prevVal) => {
      if (prevVal && !nextVal) {
        await syncLTARRefs(currentRow.value.row);
        currentRow.value.row = { ...currentRow.value.row, ...state.value };
        currentRow.value.oldRow = { ...currentRow.value.row, ...state.value };
      }
    });
    const __returned__ = { props, currentRow, meta, isNew, state, syncLTARRefs };
    Object.defineProperty(__returned__, "__isScriptSetup", { enumerable: false, value: true });
    return __returned__;
  }
});
function _sfc_render$1(_ctx, _cache, $props, $setup, $data, $options) {
  return renderSlot(_ctx.$slots, "default", { state: $setup.state });
}
var __nuxt_component_5 = /* @__PURE__ */ _export_sfc(_sfc_main$1, [["render", _sfc_render$1]]);
const _sfc_main = /* @__PURE__ */ defineComponent({
  __name: "Grid",
  setup(__props, { expose }) {
    const meta = inject(MetaInj);
    const view = inject(ActiveViewInj);
    const isPublicView = inject(IsPublicInj, ref(false));
    const fields = inject(FieldsInj, ref([]));
    const readOnly = inject(ReadonlyInj, false);
    const isLocked = inject(IsLockedInj, false);
    const reloadViewDataHook = inject(ReloadViewDataHookInj);
    const openNewRecordFormHook = inject(OpenNewRecordFormHookInj);
    const { isUIAllowed } = useUIPermission();
    const isView = false;
    const selected = reactive({ row: null, col: null });
    let editEnabled = ref(false);
    const { xWhere, isPkAvail, cellRefs } = useSmartsheetStoreOrThrow();
    const addColumnDropdown = ref(false);
    const _contextMenu = ref(false);
    const contextMenu = computed({
      get: () => _contextMenu.value,
      set: (val) => {
        if (!readOnly) {
          _contextMenu.value = val;
        }
      }
    });
    const contextMenuTarget = ref(false);
    const expandedFormDlg = ref(false);
    const expandedFormRow = ref();
    const expandedFormRowState = ref();
    const visibleColLength = computed(() => {
      var _a;
      return (_a = fields.value) == null ? void 0 : _a.length;
    });
    const {
      loadData,
      paginationData,
      formattedData: data,
      updateOrSaveRow,
      changePage,
      addEmptyRow,
      deleteRow,
      deleteSelectedRows,
      selectedAllRecords,
      removeLastEmptyRow
    } = useViewData(meta, view, xWhere);
    const { loadGridViewColumns, updateWidth, resizingColWidth, resizingCol } = useGridViewColumnWidth(view);
    onMounted(loadGridViewColumns);
    provide(IsFormInj, ref(false));
    provide(IsGridInj, true);
    provide(PaginationDataInj, paginationData);
    provide(ChangePageInj, changePage);
    provide(ReadonlyInj, !isUIAllowed("xcDatatableEditable"));
    reloadViewDataHook == null ? void 0 : reloadViewDataHook.on(async () => {
      await loadData();
    });
    const expandForm = (row, state) => {
      expandedFormRow.value = row;
      expandedFormRowState.value = state;
      expandedFormDlg.value = true;
    };
    openNewRecordFormHook == null ? void 0 : openNewRecordFormHook.on(async () => {
      const newRow = await addEmptyRow();
      expandForm(newRow);
    });
    const selectCell = (row, col) => {
      selected.row = row;
      selected.col = col;
    };
    watch(() => {
      var _a;
      return (_a = view == null ? void 0 : view.value) == null ? void 0 : _a.id;
    }, async (n, o) => {
      if (n && o && n !== o) {
        await loadData();
      }
    }, { immediate: true });
    const onresize = (colID, event) => {
      updateWidth(colID, event.detail);
    };
    const onXcResizing = (cn, event) => {
      resizingCol.value = cn;
      resizingColWidth.value = event.detail;
    };
    expose({
      loadData
    });
    watch(contextMenu, () => {
      if (!contextMenu.value) {
        contextMenuTarget.value = false;
      }
    });
    const clearCell = async (ctx) => {
      const rowObj = data.value[ctx.row];
      const columnObj = fields.value[ctx.col];
      if (isVirtualCol(columnObj)) {
        return;
      }
      rowObj.row[columnObj.title] = null;
      await updateOrSaveRow(rowObj, columnObj.title);
    };
    const { copy } = useClipboard();
    const makeEditable = (row, col) => {
      if (isPublicView.value || editEnabled.value || isView) {
        return;
      }
      if (!isPkAvail.value && !row.rowMeta.new) {
        message.info("Update not allowed for table which doesn't have primary Key");
        return;
      }
      if (col.ai) {
        message.info("Auto Increment field is not editable");
        return;
      }
      if (col.pk && !row.rowMeta.new) {
        message.info("Editing primary key not supported");
        return;
      }
      return editEnabled.value = true;
    };
    const onKeyDown = async (e) => {
      var _a;
      if (selected.row === null || selected.col === null)
        return;
      switch (e.key) {
        case "Tab":
          e.preventDefault();
          if (e.shiftKey) {
            if (selected.col > 0) {
              selected.col--;
            } else if (selected.row > 0) {
              selected.row--;
              selected.col = visibleColLength.value - 1;
            }
          } else {
            if (selected.col < visibleColLength.value - 1) {
              selected.col++;
            } else if (selected.row < data.value.length - 1) {
              selected.row++;
              selected.col = 0;
            }
          }
          break;
        case "Enter":
          e.preventDefault();
          makeEditable(data.value[selected.row], fields.value[selected.col]);
          break;
        case "Delete":
          e.preventDefault();
          await clearCell(selected);
          break;
        case "ArrowRight":
          e.preventDefault();
          if (selected.col < visibleColLength.value - 1)
            selected.col++;
          break;
        case "ArrowLeft":
          e.preventDefault();
          if (selected.col > 0)
            selected.col--;
          break;
        case "ArrowUp":
          e.preventDefault();
          if (selected.row > 0)
            selected.row--;
          break;
        case "ArrowDown":
          e.preventDefault();
          if (selected.row < data.value.length - 1)
            selected.row++;
          break;
        default:
          {
            const rowObj = data.value[selected.row];
            const columnObj = fields.value[selected.col];
            if (e.metaKey || e.ctrlKey) {
              switch (e.keyCode) {
                case 67:
                  await copy(rowObj.row[columnObj.title] || "");
                  break;
              }
            }
            if (editEnabled.value || e.ctrlKey || e.altKey || e.metaKey) {
              return;
            }
            if (((_a = e == null ? void 0 : e.key) == null ? void 0 : _a.length) === 1) {
              if (!isPkAvail && !rowObj.rowMeta.new) {
                return message.info("Update not allowed for table which doesn't have primary Key");
              }
              if (makeEditable(rowObj, columnObj)) {
                rowObj.row[columnObj.title] = "";
              }
            }
          }
          break;
      }
    };
    useEventListener(document, "keydown", onKeyDown);
    const smartTable = ref(null);
    onClickOutside(smartTable, () => {
      if (selected.col === null)
        return;
      const activeCol = fields.value[selected.col];
      if (editEnabled.value && (isVirtualCol(activeCol) || activeCol.uidt === UITypes.JSON))
        return;
      selected.row = null;
      selected.col = null;
    });
    const onNavigate = (dir) => {
      if (selected.row === null || selected.col === null)
        return;
      switch (dir) {
        case NavigateDir.NEXT:
          if (selected.row < data.value.length - 1) {
            selected.row++;
          } else {
            editEnabled.value = false;
          }
          break;
        case NavigateDir.PREV:
          if (selected.row > 0) {
            selected.row--;
          } else {
            editEnabled.value = false;
          }
          break;
      }
    };
    const __returned__ = { meta, view, isPublicView, fields, readOnly, isLocked, reloadViewDataHook, openNewRecordFormHook, isUIAllowed, isView, selected, editEnabled, xWhere, isPkAvail, cellRefs, addColumnDropdown, _contextMenu, contextMenu, contextMenuTarget, expandedFormDlg, expandedFormRow, expandedFormRowState, visibleColLength, loadData, paginationData, data, updateOrSaveRow, changePage, addEmptyRow, deleteRow, deleteSelectedRows, selectedAllRecords, removeLastEmptyRow, loadGridViewColumns, updateWidth, resizingColWidth, resizingCol, expandForm, selectCell, onresize, onXcResizing, clearCell, copy, makeEditable, onKeyDown, smartTable, onNavigate, isVirtualCol, enumColor };
    Object.defineProperty(__returned__, "__isScriptSetup", { enumerable: false, value: true });
    return __returned__;
  }
});
const _withScopeId = (n) => (pushScopeId("data-v-886a47e2"), n = n(), popScopeId(), n);
const _hoisted_1 = { class: "flex flex-col h-full min-h-0 w-full" };
const _hoisted_2 = { class: "nc-grid-wrapper min-h-0 flex-1 scrollbar-thin-dull" };
const _hoisted_3 = { class: "nc-grid-header border-1 bg-gray-100 sticky top[-1px]" };
const _hoisted_4 = { class: "w-full h-full bg-gray-100 flex min-w-[70px] pl-5 pr-1 items-center" };
const _hoisted_5 = /* @__PURE__ */ _withScopeId(() => /* @__PURE__ */ createBaseVNode("span", { class: "flex-1" }, null, -1));
const _hoisted_6 = {
  key: 1,
  class: "text-gray-500"
};
const _hoisted_7 = ["data-col", "data-title", "onXcresize", "onXcresizing"];
const _hoisted_8 = { class: "w-full h-full bg-gray-100 flex items-center" };
const _hoisted_9 = { class: "h-full w-[60px] flex items-center justify-center" };
const _hoisted_10 = { class: "nc-grid-row" };
const _hoisted_11 = {
  key: "row-index",
  class: "caption nc-grid-cell pl-5 pr-1"
};
const _hoisted_12 = { class: "items-center flex gap-1 min-w-[55px]" };
const _hoisted_13 = /* @__PURE__ */ _withScopeId(() => /* @__PURE__ */ createBaseVNode("span", { class: "flex-1" }, null, -1));
const _hoisted_14 = ["onClick"];
const _hoisted_15 = {
  key: 1,
  class: "cursor-pointer flex items-center border-1 active:ring rounded p-1 hover:bg-primary hover:bg-opacity-10"
};
const _hoisted_16 = ["data-key", "data-col", "data-title", "onClick", "onDblclick", "onContextmenu"];
const _hoisted_17 = { class: "w-full h-full" };
const _hoisted_18 = { key: 0 };
const _hoisted_19 = ["colspan"];
const _hoisted_20 = { class: "px-2 w-full flex items-center text-gray-500" };
const _hoisted_21 = { class: "ml-1" };
const _hoisted_22 = { class: "text-xs" };
const _hoisted_23 = { class: "text-xs" };
const _hoisted_24 = /* @__PURE__ */ _withScopeId(() => /* @__PURE__ */ createBaseVNode("span", { class: "text-xs" }, "Clear cell", -1));
const _hoisted_25 = { class: "text-xs" };
function _sfc_render(_ctx, _cache, $props, $setup, $data, $options) {
  const _component_a_checkbox = Checkbox;
  const _component_SmartsheetHeaderVirtualCell = __nuxt_component_0$5;
  const _component_SmartsheetHeaderCell = __nuxt_component_1$2;
  const _component_MdiPlus = MdiPlus;
  const _component_SmartsheetColumnEditOrAddProvider = __nuxt_component_2$1;
  const _component_a_dropdown = Dropdown;
  const _component_MdiArrowExpand = MdiArrowExpand;
  const _component_SmartsheetVirtualCell = __nuxt_component_0$6;
  const _component_SmartsheetCell = __nuxt_component_1$3;
  const _component_SmartsheetRow = __nuxt_component_5;
  const _component_a_menu_item = __unplugin_components_0$5;
  const _component_a_menu = Menu;
  const _component_SmartsheetPagination = __nuxt_component_6;
  const _component_SmartsheetExpandedForm = __nuxt_component_7$1;
  const _directive_xc_ver_resize = resolveDirective("xc-ver-resize");
  const _directive_t = resolveDirective("t");
  return openBlock(), createElementBlock("div", _hoisted_1, [
    createBaseVNode("div", _hoisted_2, [
      createVNode(_component_a_dropdown, {
        visible: $setup.contextMenu,
        "onUpdate:visible": _cache[16] || (_cache[16] = ($event) => $setup.contextMenu = $event),
        trigger: ["contextmenu"]
      }, createSlots({
        default: withCtx(() => [
          createBaseVNode("table", {
            ref: "smartTable",
            class: "xc-row-table nc-grid backgroundColorDefault !h-auto bg-white",
            onContextmenu: _cache[11] || (_cache[11] = withModifiers(($event) => $setup.contextMenu = true, ["prevent"]))
          }, [
            createBaseVNode("thead", null, [
              createBaseVNode("tr", _hoisted_3, [
                createBaseVNode("th", null, [
                  createBaseVNode("div", _hoisted_4, [
                    !$setup.readOnly ? (openBlock(), createElementBlock(Fragment, { key: 0 }, [
                      createBaseVNode("div", {
                        class: normalizeClass(["nc-no-label text-gray-500", { hidden: $setup.selectedAllRecords }])
                      }, "#", 2),
                      createBaseVNode("div", {
                        class: normalizeClass([{ hidden: !$setup.selectedAllRecords, flex: $setup.selectedAllRecords }, "nc-check-all w-full items-center"])
                      }, [
                        createVNode(_component_a_checkbox, {
                          checked: $setup.selectedAllRecords,
                          "onUpdate:checked": _cache[0] || (_cache[0] = ($event) => $setup.selectedAllRecords = $event)
                        }, null, 8, ["checked"]),
                        _hoisted_5
                      ], 2)
                    ], 64)) : (openBlock(), createElementBlock("div", _hoisted_6, "#"))
                  ])
                ]),
                (openBlock(true), createElementBlock(Fragment, null, renderList($setup.fields, (col) => {
                  return withDirectives((openBlock(), createElementBlock("th", {
                    key: col.title,
                    "data-col": col.id,
                    "data-title": col.title,
                    onXcresize: ($event) => $setup.onresize(col.id, $event),
                    onXcresizing: ($event) => $setup.onXcResizing(col.title, $event),
                    onXcresized: _cache[1] || (_cache[1] = ($event) => $setup.resizingCol = null)
                  }, [
                    createBaseVNode("div", _hoisted_8, [
                      $setup.isVirtualCol(col) ? (openBlock(), createBlock(_component_SmartsheetHeaderVirtualCell, {
                        key: 0,
                        column: col,
                        "hide-menu": $setup.readOnly
                      }, null, 8, ["column", "hide-menu"])) : (openBlock(), createBlock(_component_SmartsheetHeaderCell, {
                        key: 1,
                        column: col,
                        "hide-menu": $setup.readOnly
                      }, null, 8, ["column", "hide-menu"]))
                    ])
                  ], 40, _hoisted_7)), [
                    [_directive_xc_ver_resize]
                  ]);
                }), 128)),
                !$setup.readOnly && !$setup.isLocked && $setup.isUIAllowed("add-column") ? withDirectives((openBlock(), createElementBlock("th", {
                  key: 0,
                  class: "cursor-pointer",
                  onClick: _cache[7] || (_cache[7] = withModifiers(($event) => $setup.addColumnDropdown = true, ["stop"]))
                }, [
                  createVNode(_component_a_dropdown, {
                    visible: $setup.addColumnDropdown,
                    "onUpdate:visible": _cache[6] || (_cache[6] = ($event) => $setup.addColumnDropdown = $event),
                    trigger: ["click"]
                  }, {
                    overlay: withCtx(() => [
                      $setup.addColumnDropdown ? (openBlock(), createBlock(_component_SmartsheetColumnEditOrAddProvider, {
                        key: 0,
                        onSubmit: _cache[2] || (_cache[2] = ($event) => $setup.addColumnDropdown = false),
                        onCancel: _cache[3] || (_cache[3] = ($event) => $setup.addColumnDropdown = false),
                        onClick: _cache[4] || (_cache[4] = withModifiers(() => {
                        }, ["stop"])),
                        onKeydown: _cache[5] || (_cache[5] = withModifiers(() => {
                        }, ["stop"]))
                      })) : createCommentVNode("", true)
                    ]),
                    default: withCtx(() => [
                      createBaseVNode("div", _hoisted_9, [
                        createVNode(_component_MdiPlus, { class: "text-sm nc-column-add" })
                      ])
                    ]),
                    _: 1
                  }, 8, ["visible"])
                ])), [
                  [_directive_t, ["c:column:add"]]
                ]) : createCommentVNode("", true)
              ])
            ]),
            createBaseVNode("tbody", null, [
              (openBlock(true), createElementBlock(Fragment, null, renderList($setup.data, (row, rowIndex) => {
                return openBlock(), createBlock(_component_SmartsheetRow, {
                  key: rowIndex,
                  row
                }, {
                  default: withCtx(({ state }) => {
                    var _a, _b;
                    return [
                      createBaseVNode("tr", _hoisted_10, [
                        createBaseVNode("td", _hoisted_11, [
                          createBaseVNode("div", _hoisted_12, [
                            !$setup.readOnly && !$setup.isLocked ? (openBlock(), createElementBlock("div", {
                              key: 0,
                              class: normalizeClass(["nc-row-no text-xs text-gray-500", { hidden: row.rowMeta.selected }])
                            }, toDisplayString(rowIndex + 1), 3)) : createCommentVNode("", true),
                            !$setup.readOnly ? (openBlock(), createElementBlock("div", {
                              key: 1,
                              class: normalizeClass([{ hidden: !row.rowMeta.selected, flex: row.rowMeta.selected }, "nc-row-expand-and-checkbox"])
                            }, [
                              createVNode(_component_a_checkbox, {
                                checked: row.rowMeta.selected,
                                "onUpdate:checked": ($event) => row.rowMeta.selected = $event
                              }, null, 8, ["checked", "onUpdate:checked"])
                            ], 2)) : createCommentVNode("", true),
                            _hoisted_13,
                            !$setup.readOnly && !$setup.isLocked ? (openBlock(), createElementBlock("div", {
                              key: 2,
                              class: normalizeClass(["nc-expand", { "nc-comment": (_a = row.rowMeta) == null ? void 0 : _a.commentCount }])
                            }, [
                              ((_b = row.rowMeta) == null ? void 0 : _b.commentCount) ? (openBlock(), createElementBlock("span", {
                                key: 0,
                                class: "py-1 px-3 rounded-full text-xs cursor-pointer select-none transform hover:scale-110",
                                style: normalizeStyle({ backgroundColor: $setup.enumColor.light[row.rowMeta.commentCount % $setup.enumColor.light.length] }),
                                onClick: ($event) => $setup.expandForm(row, state)
                              }, toDisplayString(row.rowMeta.commentCount), 13, _hoisted_14)) : (openBlock(), createElementBlock("div", _hoisted_15, [
                                createVNode(_component_MdiArrowExpand, {
                                  class: "select-none transform hover:text-accent hover:scale-120 nc-row-expand",
                                  onClick: ($event) => $setup.expandForm(row, state)
                                }, null, 8, ["onClick"])
                              ]))
                            ], 2)) : createCommentVNode("", true)
                          ])
                        ]),
                        (openBlock(true), createElementBlock(Fragment, null, renderList($setup.fields, (columnObj, colIndex) => {
                          return openBlock(), createElementBlock("td", {
                            ref_for: true,
                            ref: $setup.cellRefs.set,
                            key: columnObj.id,
                            class: normalizeClass(["cell relative cursor-pointer nc-grid-cell", {
                              active: !$setup.isPublicView && $setup.selected.col === colIndex && $setup.selected.row === rowIndex
                            }]),
                            "data-key": rowIndex + columnObj.id,
                            "data-col": columnObj.id,
                            "data-title": columnObj.title,
                            onClick: ($event) => $setup.selectCell(rowIndex, colIndex),
                            onDblclick: ($event) => $setup.makeEditable(row, columnObj),
                            onContextmenu: ($event) => $setup.contextMenuTarget = { row: rowIndex, col: colIndex }
                          }, [
                            createBaseVNode("div", _hoisted_17, [
                              $setup.isVirtualCol(columnObj) ? (openBlock(), createBlock(_component_SmartsheetVirtualCell, {
                                key: 0,
                                modelValue: row.row[columnObj.title],
                                "onUpdate:modelValue": ($event) => row.row[columnObj.title] = $event,
                                column: columnObj,
                                active: $setup.selected.col === colIndex && $setup.selected.row === rowIndex,
                                row,
                                onNavigate: $setup.onNavigate
                              }, null, 8, ["modelValue", "onUpdate:modelValue", "column", "active", "row"])) : (openBlock(), createBlock(_component_SmartsheetCell, {
                                key: 1,
                                modelValue: row.row[columnObj.title],
                                "onUpdate:modelValue": ($event) => row.row[columnObj.title] = $event,
                                column: columnObj,
                                "edit-enabled": $setup.isUIAllowed("xcDatatableEditable") && $setup.editEnabled && $setup.selected.col === colIndex && $setup.selected.row === rowIndex,
                                "row-index": rowIndex,
                                active: $setup.selected.col === colIndex && $setup.selected.row === rowIndex,
                                "onUpdate:editEnabled": _cache[8] || (_cache[8] = ($event) => $setup.editEnabled = false),
                                onSave: ($event) => $setup.updateOrSaveRow(row, columnObj.title),
                                onNavigate: $setup.onNavigate,
                                onCancel: _cache[9] || (_cache[9] = ($event) => $setup.editEnabled = false)
                              }, null, 8, ["modelValue", "onUpdate:modelValue", "column", "edit-enabled", "row-index", "active", "onSave"]))
                            ])
                          ], 42, _hoisted_16);
                        }), 128))
                      ])
                    ];
                  }),
                  _: 2
                }, 1032, ["row"]);
              }), 128)),
              !$setup.isView && !$setup.isLocked && !$setup.isPublicView && $setup.isUIAllowed("xcDatatableEditable") ? (openBlock(), createElementBlock("tr", _hoisted_18, [
                withDirectives((openBlock(), createElementBlock("td", {
                  colspan: $setup.visibleColLength + 1,
                  class: "text-left pointer nc-grid-add-new-cell cursor-pointer",
                  onClick: _cache[10] || (_cache[10] = ($event) => $setup.addEmptyRow())
                }, [
                  createBaseVNode("div", _hoisted_20, [
                    createVNode(_component_MdiPlus, { class: "text-pint-500 text-xs ml-2 text-primary" }),
                    createBaseVNode("span", _hoisted_21, toDisplayString(_ctx.$t("activity.addRow")), 1)
                  ])
                ], 8, _hoisted_19)), [
                  [_directive_t, ["c:row:add:grid-bottom"]]
                ])
              ])) : createCommentVNode("", true)
            ])
          ], 544)
        ]),
        _: 2
      }, [
        !$setup.isLocked && $setup.isUIAllowed("xcDatatableEditable") ? {
          name: "overlay",
          fn: withCtx(() => [
            createVNode(_component_a_menu, {
              class: "bg-white shadow",
              onClick: _cache[15] || (_cache[15] = ($event) => $setup.contextMenu = false)
            }, {
              default: withCtx(() => [
                $setup.contextMenuTarget ? (openBlock(), createBlock(_component_a_menu_item, {
                  key: 0,
                  onClick: _cache[12] || (_cache[12] = ($event) => $setup.deleteRow($setup.contextMenuTarget.row))
                }, {
                  default: withCtx(() => [
                    createBaseVNode("span", _hoisted_22, toDisplayString(_ctx.$t("activity.deleteRow")), 1)
                  ]),
                  _: 1
                })) : createCommentVNode("", true),
                createVNode(_component_a_menu_item, { onClick: $setup.deleteSelectedRows }, {
                  default: withCtx(() => [
                    createBaseVNode("span", _hoisted_23, toDisplayString(_ctx.$t("activity.deleteSelectedRow")), 1)
                  ]),
                  _: 1
                }, 8, ["onClick"]),
                $setup.contextMenuTarget ? (openBlock(), createBlock(_component_a_menu_item, {
                  key: 1,
                  onClick: _cache[13] || (_cache[13] = ($event) => $setup.clearCell($setup.contextMenuTarget))
                }, {
                  default: withCtx(() => [
                    _hoisted_24
                  ]),
                  _: 1
                })) : createCommentVNode("", true),
                $setup.contextMenuTarget ? (openBlock(), createBlock(_component_a_menu_item, {
                  key: 2,
                  onClick: _cache[14] || (_cache[14] = ($event) => $setup.addEmptyRow($setup.contextMenuTarget.row + 1))
                }, {
                  default: withCtx(() => [
                    createBaseVNode("span", _hoisted_25, toDisplayString(_ctx.$t("activity.insertRow")), 1)
                  ]),
                  _: 1
                })) : createCommentVNode("", true)
              ]),
              _: 1
            })
          ])
        } : void 0
      ]), 1032, ["visible"])
    ]),
    createVNode(_component_SmartsheetPagination),
    $setup.expandedFormRow && $setup.expandedFormDlg ? (openBlock(), createBlock(_component_SmartsheetExpandedForm, {
      key: 0,
      modelValue: $setup.expandedFormDlg,
      "onUpdate:modelValue": _cache[17] || (_cache[17] = ($event) => $setup.expandedFormDlg = $event),
      row: $setup.expandedFormRow,
      state: $setup.expandedFormRowState,
      meta: $setup.meta,
      onCancel: $setup.removeLastEmptyRow
    }, null, 8, ["modelValue", "row", "state", "meta", "onCancel"])) : createCommentVNode("", true)
  ]);
}
var __nuxt_component_1 = /* @__PURE__ */ _export_sfc(_sfc_main, [["render", _sfc_render], ["__scopeId", "data-v-886a47e2"]]);
export { ToggleDrawer as T, __nuxt_component_5 as _, __nuxt_component_6 as a, useViewColumns as b, __unplugin_components_10 as c, __nuxt_component_1 as d, __nuxt_component_0 as e, useViewData as u };
