import { _ as _export_sfc, d as defineComponent, a5 as useApi, ak as useRoute, t as reactive, r as ref, x as onMounted, a9 as nextTick, o as openBlock, l as createBlock, k as withCtx, $ as message, a2 as extractSdkResponseErrorMsg, n as Card, b as createBaseVNode, z as toDisplayString, j as createVNode, dZ as projectTitleValidator, dG as navigateTo, W as Input, X as __unplugin_components_2, O as Button, Y as Form } from "./entry-3ffd12c8.mjs";
import { _ as __unplugin_components_4 } from "./rocket-launch-outline-8b24fa22.mjs";
import { u as useSidebar } from "./index-75f7d1ec.mjs";
import "./index-9b24011f.mjs";
const _sfc_main = /* @__PURE__ */ defineComponent({
  __name: "[id]",
  setup(__props, { expose }) {
    expose();
    const { api } = useApi();
    useSidebar({ hasSidebar: false });
    const route = useRoute();
    const nameValidationRules = [
      {
        required: true,
        message: "Project name is required"
      },
      projectTitleValidator
    ];
    const formState = reactive({
      title: ""
    });
    const getProject = async () => {
      try {
        const result = await api.project.read(route.params.id);
        formState.title = result.title;
      } catch (e) {
        message.error(await extractSdkResponseErrorMsg(e));
      }
    };
    const renameProject = async () => {
      try {
        await api.project.update(route.params.id, formState);
        navigateTo(`/nc/${route.params.id}`);
      } catch (e) {
        message.error(await extractSdkResponseErrorMsg(e));
      }
    };
    const form = ref();
    onMounted(async () => {
      await getProject();
      await nextTick(() => {
        setTimeout(() => {
          var _a, _b;
          const input = (_b = (_a = form.value) == null ? void 0 : _a.$el) == null ? void 0 : _b.querySelector("input[type=text]");
          input.setSelectionRange(0, formState.title.length);
          input.focus();
        }, 500);
      });
    });
    const __returned__ = { api, route, nameValidationRules, formState, getProject, renameProject, form, MaterialSymbolsRocketLaunchOutline: __unplugin_components_4 };
    Object.defineProperty(__returned__, "__isScriptSetup", { enumerable: false, value: true });
    return __returned__;
  }
});
const _hoisted_1 = { class: "text-3xl text-center font-semibold mb-2" };
function _sfc_render(_ctx, _cache, $props, $setup, $data, $options) {
  const _component_a_input = Input;
  const _component_a_form_item = __unplugin_components_2;
  const _component_a_button = Button;
  const _component_a_form = Form;
  const _component_a_card = Card;
  return openBlock(), createBlock(_component_a_card, { class: "w-[500px] !mx-auto !mt-100px shadow-md" }, {
    default: withCtx(() => [
      createBaseVNode("h3", _hoisted_1, toDisplayString(_ctx.$t("activity.editProject")), 1),
      createVNode(_component_a_form, {
        ref: "form",
        model: $setup.formState,
        name: "basic",
        layout: "vertical",
        autocomplete: "off",
        onFinish: $setup.renameProject
      }, {
        default: withCtx(() => [
          createVNode(_component_a_form_item, {
            label: _ctx.$t("labels.projName"),
            name: "title",
            rules: $setup.nameValidationRules,
            class: "my-10 mx-10"
          }, {
            default: withCtx(() => [
              createVNode(_component_a_input, {
                value: $setup.formState.title,
                "onUpdate:value": _cache[0] || (_cache[0] = ($event) => $setup.formState.title = $event),
                name: "title",
                class: "nc-metadb-project-name"
              }, null, 8, ["value"])
            ]),
            _: 1
          }, 8, ["label"]),
          createVNode(_component_a_form_item, {
            style: { "text-align": "center" },
            class: "mt-2"
          }, {
            default: withCtx(() => [
              createVNode(_component_a_button, {
                type: "primary",
                "html-type": "submit",
                class: "mx-auto flex justify-self-center"
              }, {
                default: withCtx(() => [
                  createVNode($setup["MaterialSymbolsRocketLaunchOutline"], { class: "mr-1" }),
                  createBaseVNode("span", null, toDisplayString(_ctx.$t("general.edit")), 1)
                ]),
                _: 1
              })
            ]),
            _: 1
          })
        ]),
        _: 1
      }, 8, ["model"])
    ]),
    _: 1
  });
}
var _id_ = /* @__PURE__ */ _export_sfc(_sfc_main, [["render", _sfc_render]]);
export { _id_ as default };
