import { u as useProvideSmartsheetRowStore, a as __nuxt_component_0$1, b as __nuxt_component_1, c as __nuxt_component_0$2, d as __nuxt_component_1$1 } from "./Cell-c11652dd.mjs";
import { f as computed, a as unref, dP as getCurrentInstance, r as ref, cR as onBeforeMount, w as watch, t as reactive, dQ as isRef, dR as isReactive, dS as isReadonly, bw as onBeforeUnmount, i as inject, p as provide, a9 as nextTick, b3 as useInjectionState, dT as SharedViewPasswordInj, u as useNuxtApp, ap as useMetas, m as isVirtualCol, U as UITypes, a0 as RelationTypes, a2 as extractSdkResponseErrorMsg, dU as ErrorMessages, $ as message, _ as _export_sfc, d as defineComponent, o as openBlock, c as createElementBlock, b as createBaseVNode, l as createBlock, j as createVNode, z as toDisplayString, B as createCommentVNode, k as withCtx, g as Fragment, h as renderList, L as pushScopeId, N as popScopeId, E as createTextVNode, dV as _imports_1, O as Button, Q as __unplugin_components_2, S as __unplugin_components_3, du as __unplugin_components_3$1, X as __unplugin_components_2$1, Y as Form, aa as Modal, dL as _imports_0, ak as useRoute, cT as withAsyncContext, aD as IsPublicInj, I as IsFormInj, ay as useProvideSmartsheetStore, az as ReloadViewDataHookInj, M as MetaInj, aB as createEventHook } from "./entry-3ffd12c8.mjs";
import { _ as __unplugin_components_0 } from "./index-43418683.mjs";
import { _ as __unplugin_components_0$1 } from "./Title-43740408.mjs";
import "./index-24d4654b.mjs";
import "./close-ce95147d.mjs";
import "./star-outline-8f5da6b4.mjs";
import "./file-copy-outline-1b04e760.mjs";
import "./reload-d0c0d5ed.mjs";
import "./fileUtils-f5868683.mjs";
import "./index-707d6e88.mjs";
function unwrapObj(obj) {
  let ignoreKeys = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : [];
  return Object.keys(obj).reduce((o, k) => {
    if (ignoreKeys.includes(k))
      return o;
    o[k] = unref(obj[k]);
    return o;
  }, {});
}
function isFunction(val) {
  return typeof val === "function";
}
function isProxy(value) {
  return isReactive(value) || isReadonly(value);
}
function get(obj, stringPath, def) {
  let current = obj;
  const path = stringPath.split(".");
  for (let i = 0; i < path.length; i++) {
    if (!current[path[i]])
      return def;
    current = current[path[i]];
  }
  return current;
}
function gatherBooleanGroupProperties(group, nestedResults, property) {
  return computed(() => {
    return group.some((path) => {
      return get(nestedResults, path, {
        [property]: false
      })[property];
    });
  });
}
function gatherArrayGroupProperties(group, nestedResults, property) {
  return computed(() => {
    return group.reduce((all, path) => {
      const fetchedProperty = get(nestedResults, path, {
        [property]: false
      })[property] || [];
      return all.concat(fetchedProperty);
    }, []);
  });
}
function callRule(rule, value, siblingState, instance) {
  return rule.call(instance, unref(value), unref(siblingState), instance);
}
function normalizeValidatorResponse(result) {
  return result.$valid !== void 0 ? !result.$valid : !result;
}
function createAsyncResult(rule, model, $pending, $dirty, _ref, $response, instance) {
  let {
    $lazy,
    $rewardEarly
  } = _ref;
  let watchTargets = arguments.length > 7 && arguments[7] !== void 0 ? arguments[7] : [];
  let siblingState = arguments.length > 8 ? arguments[8] : void 0;
  let $lastInvalidState = arguments.length > 9 ? arguments[9] : void 0;
  let $lastCommittedOn = arguments.length > 10 ? arguments[10] : void 0;
  const $invalid = ref(!!$dirty.value);
  const $pendingCounter = ref(0);
  $pending.value = false;
  const $unwatch = watch([model, $dirty].concat(watchTargets, $lastCommittedOn), () => {
    if ($lazy && !$dirty.value || $rewardEarly && !$lastInvalidState.value && !$pending.value) {
      return;
    }
    let ruleResult;
    try {
      ruleResult = callRule(rule, model, siblingState, instance);
    } catch (err) {
      ruleResult = Promise.reject(err);
    }
    $pendingCounter.value++;
    $pending.value = !!$pendingCounter.value;
    $invalid.value = false;
    Promise.resolve(ruleResult).then((data) => {
      $pendingCounter.value--;
      $pending.value = !!$pendingCounter.value;
      $response.value = data;
      $invalid.value = normalizeValidatorResponse(data);
    }).catch((error) => {
      $pendingCounter.value--;
      $pending.value = !!$pendingCounter.value;
      $response.value = error;
      $invalid.value = true;
    });
  }, {
    immediate: true,
    deep: typeof model === "object"
  });
  return {
    $invalid,
    $unwatch
  };
}
function createSyncResult(rule, model, $dirty, _ref2, $response, instance, siblingState, $lastInvalidState) {
  let {
    $lazy,
    $rewardEarly
  } = _ref2;
  const $unwatch = () => ({});
  const $invalid = computed(() => {
    if ($lazy && !$dirty.value || $rewardEarly && !$lastInvalidState.value) {
      return false;
    }
    let returnValue = true;
    try {
      const result = callRule(rule, model, siblingState, instance);
      $response.value = result;
      returnValue = normalizeValidatorResponse(result);
    } catch (err) {
      $response.value = err;
    }
    return returnValue;
  });
  return {
    $unwatch,
    $invalid
  };
}
function createValidatorResult(rule, model, $dirty, config, instance, validatorName, propertyKey, propertyPath, siblingState, $lastInvalidState, $lastCommittedOn) {
  const $pending = ref(false);
  const $params = rule.$params || {};
  const $response = ref(null);
  let $invalid;
  let $unwatch;
  if (rule.$async) {
    ({
      $invalid,
      $unwatch
    } = createAsyncResult(rule.$validator, model, $pending, $dirty, config, $response, instance, rule.$watchTargets, siblingState, $lastInvalidState, $lastCommittedOn));
  } else {
    ({
      $invalid,
      $unwatch
    } = createSyncResult(rule.$validator, model, $dirty, config, $response, instance, siblingState, $lastInvalidState));
  }
  const message2 = rule.$message;
  const $message = isFunction(message2) ? computed(() => message2(unwrapObj({
    $pending,
    $invalid,
    $params: unwrapObj($params),
    $model: model,
    $response,
    $validator: validatorName,
    $propertyPath: propertyPath,
    $property: propertyKey
  }))) : message2 || "";
  return {
    $message,
    $params,
    $pending,
    $invalid,
    $response,
    $unwatch
  };
}
function sortValidations() {
  let validationsRaw = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
  const validations = unref(validationsRaw);
  const validationKeys = Object.keys(validations);
  const rules = {};
  const nestedValidators = {};
  const config = {};
  let validationGroups = null;
  validationKeys.forEach((key) => {
    const v = validations[key];
    switch (true) {
      case isFunction(v.$validator):
        rules[key] = v;
        break;
      case isFunction(v):
        rules[key] = {
          $validator: v
        };
        break;
      case key === "$validationGroups":
        validationGroups = v;
        break;
      case key.startsWith("$"):
        config[key] = v;
        break;
      default:
        nestedValidators[key] = v;
    }
  });
  return {
    rules,
    nestedValidators,
    config,
    validationGroups
  };
}
function _empty() {
}
const ROOT_PATH = "__root";
function _call(body, then, direct) {
  if (direct) {
    return then ? then(body()) : body();
  }
  try {
    var result = Promise.resolve(body());
    return then ? result.then(then) : result;
  } catch (e) {
    return Promise.reject(e);
  }
}
function _callIgnored(body, direct) {
  return _call(body, _empty, direct);
}
function _invoke(body, then) {
  var result = body();
  if (result && result.then) {
    return result.then(then);
  }
  return then(result);
}
function _async(f) {
  return function() {
    for (var args = [], i = 0; i < arguments.length; i++) {
      args[i] = arguments[i];
    }
    try {
      return Promise.resolve(f.apply(this, args));
    } catch (e) {
      return Promise.reject(e);
    }
  };
}
function createValidationResults(rules, model, key, resultsCache, path, config, instance, externalResults, siblingState) {
  const ruleKeys = Object.keys(rules);
  const cachedResult = resultsCache.get(path, rules);
  const $dirty = ref(false);
  const $lastInvalidState = ref(false);
  const $lastCommittedOn = ref(0);
  if (cachedResult) {
    if (!cachedResult.$partial)
      return cachedResult;
    cachedResult.$unwatch();
    $dirty.value = cachedResult.$dirty.value;
  }
  const result = {
    $dirty,
    $path: path,
    $touch: () => {
      if (!$dirty.value)
        $dirty.value = true;
    },
    $reset: () => {
      if ($dirty.value)
        $dirty.value = false;
    },
    $commit: () => {
    }
  };
  if (!ruleKeys.length) {
    cachedResult && resultsCache.set(path, rules, result);
    return result;
  }
  ruleKeys.forEach((ruleKey) => {
    result[ruleKey] = createValidatorResult(rules[ruleKey], model, result.$dirty, config, instance, ruleKey, key, path, siblingState, $lastInvalidState, $lastCommittedOn);
  });
  result.$externalResults = computed(() => {
    if (!externalResults.value)
      return [];
    return [].concat(externalResults.value).map((stringError, index) => ({
      $propertyPath: path,
      $property: key,
      $validator: "$externalResults",
      $uid: `${path}-externalResult-${index}`,
      $message: stringError,
      $params: {},
      $response: null,
      $pending: false
    }));
  });
  result.$invalid = computed(() => {
    const r = ruleKeys.some((ruleKey) => unref(result[ruleKey].$invalid));
    $lastInvalidState.value = r;
    return !!result.$externalResults.value.length || r;
  });
  result.$pending = computed(() => ruleKeys.some((ruleKey) => unref(result[ruleKey].$pending)));
  result.$error = computed(() => result.$dirty.value ? result.$pending.value || result.$invalid.value : false);
  result.$silentErrors = computed(() => ruleKeys.filter((ruleKey) => unref(result[ruleKey].$invalid)).map((ruleKey) => {
    const res = result[ruleKey];
    return reactive({
      $propertyPath: path,
      $property: key,
      $validator: ruleKey,
      $uid: `${path}-${ruleKey}`,
      $message: res.$message,
      $params: res.$params,
      $response: res.$response,
      $pending: res.$pending
    });
  }).concat(result.$externalResults.value));
  result.$errors = computed(() => result.$dirty.value ? result.$silentErrors.value : []);
  result.$unwatch = () => ruleKeys.forEach((ruleKey) => {
    result[ruleKey].$unwatch();
  });
  result.$commit = () => {
    $lastInvalidState.value = true;
    $lastCommittedOn.value = Date.now();
  };
  resultsCache.set(path, rules, result);
  return result;
}
function collectNestedValidationResults(validations, nestedState, path, resultsCache, config, instance, nestedExternalResults) {
  const nestedValidationKeys = Object.keys(validations);
  if (!nestedValidationKeys.length)
    return {};
  return nestedValidationKeys.reduce((results, nestedKey) => {
    results[nestedKey] = setValidations({
      validations: validations[nestedKey],
      state: nestedState,
      key: nestedKey,
      parentKey: path,
      resultsCache,
      globalConfig: config,
      instance,
      externalResults: nestedExternalResults
    });
    return results;
  }, {});
}
function createMetaFields(results, nestedResults, childResults) {
  const allResults = computed(() => [nestedResults, childResults].filter((res) => res).reduce((allRes, res) => {
    return allRes.concat(Object.values(unref(res)));
  }, []));
  const $dirty = computed({
    get() {
      return results.$dirty.value || (allResults.value.length ? allResults.value.every((r) => r.$dirty) : false);
    },
    set(v) {
      results.$dirty.value = v;
    }
  });
  const $silentErrors = computed(() => {
    const modelErrors = unref(results.$silentErrors) || [];
    const nestedErrors = allResults.value.filter((result) => (unref(result).$silentErrors || []).length).reduce((errors, result) => {
      return errors.concat(...result.$silentErrors);
    }, []);
    return modelErrors.concat(nestedErrors);
  });
  const $errors = computed(() => {
    const modelErrors = unref(results.$errors) || [];
    const nestedErrors = allResults.value.filter((result) => (unref(result).$errors || []).length).reduce((errors, result) => {
      return errors.concat(...result.$errors);
    }, []);
    return modelErrors.concat(nestedErrors);
  });
  const $invalid = computed(() => allResults.value.some((r) => r.$invalid) || unref(results.$invalid) || false);
  const $pending = computed(() => allResults.value.some((r) => unref(r.$pending)) || unref(results.$pending) || false);
  const $anyDirty = computed(() => allResults.value.some((r) => r.$dirty) || allResults.value.some((r) => r.$anyDirty) || $dirty.value);
  const $error = computed(() => $dirty.value ? $pending.value || $invalid.value : false);
  const $touch = () => {
    results.$touch();
    allResults.value.forEach((result) => {
      result.$touch();
    });
  };
  const $commit = () => {
    results.$commit();
    allResults.value.forEach((result) => {
      result.$commit();
    });
  };
  const $reset = () => {
    results.$reset();
    allResults.value.forEach((result) => {
      result.$reset();
    });
  };
  if (allResults.value.length && allResults.value.every((nr) => nr.$dirty))
    $touch();
  return {
    $dirty,
    $errors,
    $invalid,
    $anyDirty,
    $error,
    $pending,
    $touch,
    $reset,
    $silentErrors,
    $commit
  };
}
function setValidations(_ref) {
  const $validate = _async(function() {
    $touch();
    return _invoke(function() {
      if (mergedConfig.$rewardEarly) {
        $commit();
        return _callIgnored(nextTick);
      }
    }, function() {
      return _call(nextTick, function() {
        return new Promise((resolve) => {
          if (!$pending.value)
            return resolve(!$invalid.value);
          const unwatch = watch($pending, () => {
            resolve(!$invalid.value);
            unwatch();
          });
        });
      });
    });
  });
  let {
    validations,
    state,
    key,
    parentKey,
    childResults,
    resultsCache,
    globalConfig = {},
    instance,
    externalResults
  } = _ref;
  const path = parentKey ? `${parentKey}.${key}` : key;
  const {
    rules,
    nestedValidators,
    config,
    validationGroups
  } = sortValidations(validations);
  const mergedConfig = Object.assign({}, globalConfig, config);
  const nestedState = key ? computed(() => {
    const s = unref(state);
    return s ? unref(s[key]) : void 0;
  }) : state;
  const cachedExternalResults = Object.assign({}, unref(externalResults) || {});
  const nestedExternalResults = computed(() => {
    const results2 = unref(externalResults);
    if (!key)
      return results2;
    return results2 ? unref(results2[key]) : void 0;
  });
  const results = createValidationResults(rules, nestedState, key, resultsCache, path, mergedConfig, instance, nestedExternalResults, state);
  const nestedResults = collectNestedValidationResults(nestedValidators, nestedState, path, resultsCache, mergedConfig, instance, nestedExternalResults);
  const $validationGroups = {};
  if (validationGroups) {
    Object.entries(validationGroups).forEach((_ref2) => {
      let [key2, group] = _ref2;
      $validationGroups[key2] = {
        $invalid: gatherBooleanGroupProperties(group, nestedResults, "$invalid"),
        $error: gatherBooleanGroupProperties(group, nestedResults, "$error"),
        $pending: gatherBooleanGroupProperties(group, nestedResults, "$pending"),
        $errors: gatherArrayGroupProperties(group, nestedResults, "$errors"),
        $silentErrors: gatherArrayGroupProperties(group, nestedResults, "$silentErrors")
      };
    });
  }
  const {
    $dirty,
    $errors,
    $invalid,
    $anyDirty,
    $error,
    $pending,
    $touch,
    $reset,
    $silentErrors,
    $commit
  } = createMetaFields(results, nestedResults, childResults);
  const $model = key ? computed({
    get: () => unref(nestedState),
    set: (val) => {
      $dirty.value = true;
      const s = unref(state);
      const external = unref(externalResults);
      if (external) {
        external[key] = cachedExternalResults[key];
      }
      if (isRef(s[key])) {
        s[key].value = val;
      } else {
        s[key] = val;
      }
    }
  }) : null;
  if (key && mergedConfig.$autoDirty) {
    watch(nestedState, () => {
      if (!$dirty.value)
        $touch();
      const external = unref(externalResults);
      if (external) {
        external[key] = cachedExternalResults[key];
      }
    }, {
      flush: "sync"
    });
  }
  function $getResultsForChild(key2) {
    return (childResults.value || {})[key2];
  }
  function $clearExternalResults() {
    if (isRef(externalResults)) {
      externalResults.value = cachedExternalResults;
    } else {
      if (Object.keys(cachedExternalResults).length === 0) {
        Object.keys(externalResults).forEach((k) => {
          delete externalResults[k];
        });
      } else {
        Object.assign(externalResults, cachedExternalResults);
      }
    }
  }
  return reactive(Object.assign({}, results, {
    $model,
    $dirty,
    $error,
    $errors,
    $invalid,
    $anyDirty,
    $pending,
    $touch,
    $reset,
    $path: path || ROOT_PATH,
    $silentErrors,
    $validate,
    $commit
  }, childResults && {
    $getResultsForChild,
    $clearExternalResults,
    $validationGroups
  }, nestedResults));
}
class ResultsStorage {
  constructor() {
    this.storage = /* @__PURE__ */ new Map();
  }
  set(path, rules, result) {
    this.storage.set(path, {
      rules,
      result
    });
  }
  checkRulesValidity(path, rules, storedRules) {
    const storedRulesKeys = Object.keys(storedRules);
    const newRulesKeys = Object.keys(rules);
    if (newRulesKeys.length !== storedRulesKeys.length)
      return false;
    const hasAllValidators = newRulesKeys.every((ruleKey) => storedRulesKeys.includes(ruleKey));
    if (!hasAllValidators)
      return false;
    return newRulesKeys.every((ruleKey) => {
      if (!rules[ruleKey].$params)
        return true;
      return Object.keys(rules[ruleKey].$params).every((paramKey) => {
        return unref(storedRules[ruleKey].$params[paramKey]) === unref(rules[ruleKey].$params[paramKey]);
      });
    });
  }
  get(path, rules) {
    const storedRuleResultPair = this.storage.get(path);
    if (!storedRuleResultPair)
      return void 0;
    const {
      rules: storedRules,
      result
    } = storedRuleResultPair;
    const isValidCache = this.checkRulesValidity(path, rules, storedRules);
    const $unwatch = result.$unwatch ? result.$unwatch : () => ({});
    if (!isValidCache)
      return {
        $dirty: result.$dirty,
        $partial: true,
        $unwatch
      };
    return result;
  }
}
const CollectFlag = {
  COLLECT_ALL: true,
  COLLECT_NONE: false
};
const VuelidateInjectChildResults = Symbol("vuelidate#injectChildResults");
const VuelidateRemoveChildResults = Symbol("vuelidate#removeChildResults");
function nestedValidations(_ref) {
  let {
    $scope,
    instance
  } = _ref;
  const childResultsRaw = {};
  const childResultsKeys = ref([]);
  const childResults = computed(() => childResultsKeys.value.reduce((results, key) => {
    results[key] = unref(childResultsRaw[key]);
    return results;
  }, {}));
  function injectChildResultsIntoParent(results, _ref2) {
    let {
      $registerAs: key,
      $scope: childScope,
      $stopPropagation
    } = _ref2;
    if ($stopPropagation || $scope === CollectFlag.COLLECT_NONE || childScope === CollectFlag.COLLECT_NONE || $scope !== CollectFlag.COLLECT_ALL && $scope !== childScope)
      return;
    childResultsRaw[key] = results;
    childResultsKeys.value.push(key);
  }
  instance.__vuelidateInjectInstances = [].concat(instance.__vuelidateInjectInstances || [], injectChildResultsIntoParent);
  function removeChildResultsFromParent(key) {
    childResultsKeys.value = childResultsKeys.value.filter((childKey) => childKey !== key);
    delete childResultsRaw[key];
  }
  instance.__vuelidateRemoveInstances = [].concat(instance.__vuelidateRemoveInstances || [], removeChildResultsFromParent);
  const sendValidationResultsToParent = inject(VuelidateInjectChildResults, []);
  provide(VuelidateInjectChildResults, instance.__vuelidateInjectInstances);
  const removeValidationResultsFromParent = inject(VuelidateRemoveChildResults, []);
  provide(VuelidateRemoveChildResults, instance.__vuelidateRemoveInstances);
  return {
    childResults,
    sendValidationResultsToParent,
    removeValidationResultsFromParent
  };
}
function ComputedProxyFactory(target) {
  return new Proxy(target, {
    get(target2, prop) {
      return typeof target2[prop] === "object" ? ComputedProxyFactory(target2[prop]) : computed(() => target2[prop]);
    }
  });
}
let uid = 0;
function useVuelidate(validations, state) {
  var _getCurrentInstance;
  let globalConfig = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {};
  if (arguments.length === 1) {
    globalConfig = validations;
    validations = void 0;
    state = void 0;
  }
  let {
    $registerAs,
    $scope = CollectFlag.COLLECT_ALL,
    $stopPropagation,
    $externalResults,
    currentVueInstance
  } = globalConfig;
  const instance = currentVueInstance || ((_getCurrentInstance = getCurrentInstance()) === null || _getCurrentInstance === void 0 ? void 0 : _getCurrentInstance.proxy);
  const componentOptions = instance ? instance.$options : {};
  if (!$registerAs) {
    uid += 1;
    $registerAs = `_vuelidate_${uid}`;
  }
  const validationResults = ref({});
  const resultsCache = new ResultsStorage();
  const {
    childResults,
    sendValidationResultsToParent,
    removeValidationResultsFromParent
  } = instance ? nestedValidations({
    $scope,
    instance
  }) : {
    childResults: ref({})
  };
  if (!validations && componentOptions.validations) {
    const rules = componentOptions.validations;
    state = ref({});
    onBeforeMount(() => {
      state.value = instance;
      watch(() => isFunction(rules) ? rules.call(state.value, new ComputedProxyFactory(state.value)) : rules, (validations2) => {
        validationResults.value = setValidations({
          validations: validations2,
          state,
          childResults,
          resultsCache,
          globalConfig,
          instance,
          externalResults: $externalResults || instance.vuelidateExternalResults
        });
      }, {
        immediate: true
      });
    });
    globalConfig = componentOptions.validationsConfig || globalConfig;
  } else {
    const validationsWatchTarget = isRef(validations) || isProxy(validations) ? validations : reactive(validations || {});
    watch(validationsWatchTarget, (newValidationRules) => {
      validationResults.value = setValidations({
        validations: newValidationRules,
        state,
        childResults,
        resultsCache,
        globalConfig,
        instance: instance !== null && instance !== void 0 ? instance : {},
        externalResults: $externalResults
      });
    }, {
      immediate: true
    });
  }
  if (instance) {
    sendValidationResultsToParent.forEach((f) => f(validationResults, {
      $registerAs,
      $scope,
      $stopPropagation
    }));
    onBeforeUnmount(() => removeValidationResultsFromParent.forEach((f) => f($registerAs)));
  }
  return computed(() => {
    return Object.assign({}, unref(validationResults.value), childResults.value);
  });
}
const req = (value) => {
  value = unref(value);
  if (Array.isArray(value))
    return !!value.length;
  if (value === void 0 || value === null) {
    return false;
  }
  if (value === false) {
    return true;
  }
  if (value instanceof Date) {
    return !isNaN(value.getTime());
  }
  if (typeof value === "object") {
    for (let _ in value)
      return true;
    return false;
  }
  return !!String(value).length;
};
const len = (value) => {
  value = unref(value);
  if (Array.isArray(value))
    return value.length;
  if (typeof value === "object") {
    return Object.keys(value).length;
  }
  return String(value).length;
};
function regex() {
  for (var _len = arguments.length, expr = new Array(_len), _key = 0; _key < _len; _key++) {
    expr[_key] = arguments[_key];
  }
  return (value) => {
    value = unref(value);
    return !req(value) || expr.every((reg) => reg.test(value));
  };
}
regex(/^[a-zA-Z]*$/);
regex(/^[a-zA-Z0-9]*$/);
regex(/^\d*(\.\d+)?$/);
const emailRegex = /^(?:[A-z0-9!#$%&'*+/=?^_`{|}~-]+(?:\.[A-z0-9!#$%&'*+/=?^_`{|}~-]+)*|"(?:[\x01-\x08\x0b\x0c\x0e-\x1f\x21\x23-\x5b\x5d-\x7f]|[\x01-\x09\x0b\x0c\x0e-\x7f])*")@(?:(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\.)+[a-z0-9]{2,}(?:[a-z0-9-]*[a-z0-9])?|\[(?:(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.){3}(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?|[a-z0-9-]*[a-z0-9]:(?:[\x01-\x08\x0b\x0c\x0e-\x1f\x21-\x5a\x53-\x7f]|\\[\x01-\x09\x0b\x0c\x0e-\x7f])+)\])$/i;
regex(emailRegex);
function minLength$1(length) {
  return (value) => !req(value) || len(value) >= unref(length);
}
function minLength(min) {
  return {
    $validator: minLength$1(min),
    $message: (_ref) => {
      let {
        $params
      } = _ref;
      return `This field should be at least ${$params.min} characters long`;
    },
    $params: {
      min,
      type: "minLength"
    }
  };
}
function required$1(value) {
  if (typeof value === "string") {
    value = value.trim();
  }
  return req(value);
}
var required = {
  $validator: required$1,
  $message: "Value is required",
  $params: {
    type: "required"
  }
};
const urlRegex = /^(?:(?:(?:https?|ftp):)?\/\/)(?:\S+(?::\S*)?@)?(?:(?!(?:10|127)(?:\.\d{1,3}){3})(?!(?:169\.254|192\.168)(?:\.\d{1,3}){2})(?!172\.(?:1[6-9]|2\d|3[0-1])(?:\.\d{1,3}){2})(?:[1-9]\d?|1\d\d|2[01]\d|22[0-3])(?:\.(?:1?\d{1,2}|2[0-4]\d|25[0-5])){2}(?:\.(?:[1-9]\d?|1\d\d|2[0-4]\d|25[0-4]))|(?:(?:[a-z0-9\u00a1-\uffff][a-z0-9\u00a1-\uffff_-]{0,62})?[a-z0-9\u00a1-\uffff]\.)+(?:[a-z\u00a1-\uffff]{2,}\.?))(?::\d{2,5})?(?:[/?#]\S*)?$/i;
regex(urlRegex);
regex(/(^[0-9]*$)|(^-[0-9]+$)/);
regex(/^[-]?\d*(\.\d+)?$/);
const [useProvideSharedFormStore, useSharedFormStore] = useInjectionState((sharedViewId) => {
  const progress = ref(false);
  const notFound = ref(false);
  const submitted = ref(false);
  const passwordDlg = ref(false);
  const password = ref(null);
  const secondsRemain = ref(0);
  provide(SharedViewPasswordInj, password);
  const sharedView = ref();
  const sharedFormView = ref();
  const meta = ref();
  const columns = ref();
  const { $api } = useNuxtApp();
  const { metas, setMeta } = useMetas();
  const formState = ref({});
  const { state: additionalState } = useProvideSmartsheetRowStore(meta, ref({
    row: formState,
    rowMeta: { new: true },
    oldRow: {}
  }));
  const formColumns = computed(() => {
    var _a, _b;
    return (_b = (_a = columns == null ? void 0 : columns.value) == null ? void 0 : _a.filter((c) => c.show)) == null ? void 0 : _b.filter((col) => !isVirtualCol(col) || col.uidt === UITypes.LinkToAnotherRecord);
  });
  const loadSharedView = async () => {
    var _a;
    try {
      const viewMeta = await $api.public.sharedViewMetaGet(sharedViewId, {
        headers: {
          "xc-password": password.value
        }
      });
      passwordDlg.value = false;
      sharedView.value = viewMeta;
      sharedFormView.value = viewMeta.view;
      meta.value = viewMeta.model;
      columns.value = (_a = viewMeta.model) == null ? void 0 : _a.columns;
      setMeta(viewMeta.model);
      const relatedMetas = { ...viewMeta.relatedMetas };
      Object.keys(relatedMetas).forEach((key) => setMeta(relatedMetas[key]));
    } catch (e) {
      if (e.response && e.response.status === 404) {
        notFound.value = true;
      } else if (await extractSdkResponseErrorMsg(e) === ErrorMessages.INVALID_SHARED_VIEW_PASSWORD) {
        passwordDlg.value = true;
      }
    }
  };
  const validators = computed(() => {
    var _a, _b;
    const obj = {
      localState: {},
      virtual: {}
    };
    for (const column of (_a = formColumns == null ? void 0 : formColumns.value) != null ? _a : []) {
      if (!isVirtualCol(column) && (column.rqd && !column.cdf || column.pk && !(column.ai || column.cdf) || column.required)) {
        obj.localState[column.title] = { required };
      } else if (column.uidt === UITypes.LinkToAnotherRecord && column.colOptions && column.colOptions.type === RelationTypes.BELONGS_TO) {
        const col = (_b = columns.value) == null ? void 0 : _b.find((c) => {
          var _a2;
          return c.id === ((_a2 = column == null ? void 0 : column.colOptions) == null ? void 0 : _a2.fk_child_column_id);
        });
        if (col && col.rqd && !col.cdf || column.required) {
          if (col) {
            obj.virtual[column.title] = { required };
          }
        }
      } else if (isVirtualCol(column) && column.required) {
        obj.virtual[column.title] = {
          minLength: minLength(1),
          required
        };
      }
    }
    return obj;
  });
  const v$ = useVuelidate(validators, computed(() => ({ localState: formState == null ? void 0 : formState.value, virtual: additionalState == null ? void 0 : additionalState.value })));
  const submitForm = async () => {
    var _a, _b, _c, _d, _e, _f, _g, _h;
    try {
      if (!await ((_a = v$.value) == null ? void 0 : _a.$validate())) {
        return;
      }
      progress.value = true;
      const data = { ...(_b = formState == null ? void 0 : formState.value) != null ? _b : {}, ...(additionalState == null ? void 0 : additionalState.value) || {} };
      const attachment = {};
      for (const col of (_f = (_e = (_d = metas == null ? void 0 : metas.value) == null ? void 0 : _d[(_c = sharedView == null ? void 0 : sharedView.value) == null ? void 0 : _c.fk_model_id]) == null ? void 0 : _e.columns) != null ? _f : []) {
        if (col.uidt === UITypes.Attachment) {
          attachment[`_${col.title}`] = data[col.title];
          delete data[col.title];
        }
      }
      await $api.public.dataCreate((_g = sharedView == null ? void 0 : sharedView.value) == null ? void 0 : _g.uuid, {
        data,
        ...attachment
      }, {
        headers: {
          "xc-password": password.value
        }
      });
      submitted.value = true;
      progress.value = false;
      await message.success(((_h = sharedFormView.value) == null ? void 0 : _h.success_msg) || "Saved successfully.");
    } catch (e) {
      console.log(e);
      await message.error(await extractSdkResponseErrorMsg(e));
    }
    progress.value = false;
  };
  watch(submitted, (nextVal) => {
    var _a, _b;
    if (nextVal && ((_a = sharedFormView.value) == null ? void 0 : _a.show_blank_form)) {
      secondsRemain.value = 5;
      const intvl = setInterval(() => {
        secondsRemain.value = secondsRemain.value - 1;
        if (secondsRemain.value < 0) {
          submitted.value = false;
          clearInterval(intvl);
        }
      }, 1e3);
    }
    if (!nextVal) {
      additionalState.value = {};
      formState.value = {};
      (_b = v$.value) == null ? void 0 : _b.$reset();
    }
  });
  return {
    sharedView,
    sharedFormView,
    loadSharedView,
    columns,
    submitForm,
    progress,
    meta,
    validators,
    v$,
    formColumns,
    formState,
    notFound,
    password,
    submitted,
    secondsRemain,
    passwordDlg
  };
}, "expanded-form-store");
function useSharedFormStoreOrThrow() {
  const sharedFormStore = useSharedFormStore();
  if (sharedFormStore == null)
    throw new Error("Please call `useProvideSharedFormStore` on the appropriate parent component");
  return sharedFormStore;
}
const _sfc_main$1 = /* @__PURE__ */ defineComponent({
  __name: "Form",
  setup(__props, { expose }) {
    expose();
    const {
      sharedFormView,
      submitForm,
      v$,
      formState,
      notFound,
      formColumns,
      submitted,
      secondsRemain,
      passwordDlg,
      password,
      loadSharedView
    } = useSharedFormStoreOrThrow();
    function isRequired(_columnObj, required2 = false) {
      var _a;
      let columnObj = _columnObj;
      if (columnObj.uidt === UITypes.LinkToAnotherRecord && columnObj.colOptions && columnObj.colOptions.type === RelationTypes.BELONGS_TO) {
        columnObj = (_a = formColumns.value) == null ? void 0 : _a.find((c) => c.id === columnObj.colOptions.fk_child_column_id);
      }
      return required2 || columnObj && columnObj.rqd && !columnObj.cdf;
    }
    const __returned__ = { sharedFormView, submitForm, v$, formState, notFound, formColumns, submitted, secondsRemain, passwordDlg, password, loadSharedView, isRequired, isVirtualCol };
    Object.defineProperty(__returned__, "__isScriptSetup", { enumerable: false, value: true });
    return __returned__;
  }
});
const _withScopeId = (n) => (pushScopeId("data-v-16a75d8b"), n = n(), popScopeId(), n);
const _hoisted_1 = { class: "bg-primary !h-[100vh] overflow-auto w-full flex flex-col" };
const _hoisted_2 = /* @__PURE__ */ _withScopeId(() => /* @__PURE__ */ createBaseVNode("div", null, [
  /* @__PURE__ */ createBaseVNode("img", {
    src: _imports_0,
    width: "30",
    class: "mx-4 mt-2"
  })
], -1));
const _hoisted_3 = { class: "m-4 mt-2 bg-white rounded p-2 flex-1" };
const _hoisted_4 = {
  key: 1,
  class: "flex justify-center"
};
const _hoisted_5 = {
  key: 0,
  style: { "min-width": "350px" },
  class: "mt-3"
};
const _hoisted_6 = {
  key: 0,
  class: "text-xs text-gray-500 text-center my-4"
};
const _hoisted_7 = {
  key: 1,
  class: "text-center"
};
const _hoisted_8 = /* @__PURE__ */ createTextVNode(" Submit Another Form");
const _hoisted_9 = {
  key: 2,
  class: ""
};
const _hoisted_10 = { class: "h-full m-0 rounded-b-0" };
const _hoisted_11 = {
  class: "nc-form-wrapper pb-10 rounded shadow-xl",
  style: { "background": "linear-gradient(180deg, #dbdbdb 0, #dbdbdb 200px, white 200px)" }
};
const _hoisted_12 = /* @__PURE__ */ _withScopeId(() => /* @__PURE__ */ createBaseVNode("div", { class: "mt-10 flex items-center justify-center flex-col" }, [
  /* @__PURE__ */ createBaseVNode("div", { class: "nc-form-banner backgroundColor darken-1 flex-col justify-center flex" }, [
    /* @__PURE__ */ createBaseVNode("div", { class: "flex items-center justify-center flex-1 h-[100px]" }, [
      /* @__PURE__ */ createBaseVNode("img", {
        src: _imports_1,
        width: "50",
        class: "mx-4"
      }),
      /* @__PURE__ */ createBaseVNode("span", { class: "text-4xl font-weight-bold" }, "NocoDB")
    ])
  ])
], -1));
const _hoisted_13 = { class: "mx-auto nc-form bg-white shadow-lg p-2 mb-10 max-w-[600px] mx-auto rounded" };
const _hoisted_14 = { class: "mt-4 text-4xl font-weight-bold text-left mx-4 mb-3 px-1" };
const _hoisted_15 = { class: "text-lg text-left mx-4 py-2 px-1 text-gray-500" };
const _hoisted_16 = { class: "h-full" };
const _hoisted_17 = { class: "flex" };
const _hoisted_18 = {
  key: 0,
  class: "mt-0"
};
const _hoisted_19 = {
  key: 0,
  class: "text-gray-500 text-[10px] mb-2 ml-1"
};
const _hoisted_20 = {
  key: 1,
  class: "mt-0"
};
const _hoisted_21 = {
  key: 0,
  class: "text-gray-500 text-[10px] mb-2 ml-1"
};
const _hoisted_22 = { class: "text-center my-9" };
const _hoisted_23 = /* @__PURE__ */ createTextVNode(" Submit");
const _hoisted_24 = { class: "w-full flex flex-col" };
const _hoisted_25 = /* @__PURE__ */ createTextVNode("This shared view is protected");
const _hoisted_26 = /* @__PURE__ */ createTextVNode("Unlock");
function _sfc_render$1(_ctx, _cache, $props, $setup, $data, $options) {
  const _component_a_alert = __unplugin_components_0;
  const _component_a_button = Button;
  const _component_SmartsheetHeaderVirtualCell = __nuxt_component_0$1;
  const _component_SmartsheetHeaderCell = __nuxt_component_1;
  const _component_SmartsheetVirtualCell = __nuxt_component_0$2;
  const _component_SmartsheetCell = __nuxt_component_1$1;
  const _component_a_col = __unplugin_components_2;
  const _component_a_row = __unplugin_components_3;
  const _component_a_typography_title = __unplugin_components_0$1;
  const _component_a_input_password = __unplugin_components_3$1;
  const _component_a_form_item = __unplugin_components_2$1;
  const _component_a_form = Form;
  const _component_a_modal = Modal;
  return openBlock(), createElementBlock("div", _hoisted_1, [
    _hoisted_2,
    createBaseVNode("div", _hoisted_3, [
      $setup.notFound ? (openBlock(), createBlock(_component_a_alert, {
        key: 0,
        type: "warning",
        class: "mx-auto mt-10 max-w-[300px]",
        message: "Not found"
      })) : $setup.submitted ? (openBlock(), createElementBlock("div", _hoisted_4, [
        $setup.sharedFormView ? (openBlock(), createElementBlock("div", _hoisted_5, [
          createVNode(_component_a_alert, {
            type: "success",
            outlined: "",
            message: $setup.sharedFormView.success_msg || "Successfully submitted form data"
          }, null, 8, ["message"]),
          $setup.sharedFormView.show_blank_form ? (openBlock(), createElementBlock("p", _hoisted_6, " New form will be loaded after " + toDisplayString($setup.secondsRemain) + " seconds ", 1)) : createCommentVNode("", true),
          $setup.sharedFormView.submit_another_form ? (openBlock(), createElementBlock("div", _hoisted_7, [
            createVNode(_component_a_button, {
              type: "primary",
              onClick: _cache[0] || (_cache[0] = ($event) => $setup.submitted = false)
            }, {
              default: withCtx(() => [
                _hoisted_8
              ]),
              _: 1
            })
          ])) : createCommentVNode("", true)
        ])) : createCommentVNode("", true)
      ])) : $setup.sharedFormView ? (openBlock(), createElementBlock("div", _hoisted_9, [
        createVNode(_component_a_row, { class: "justify-center" }, {
          default: withCtx(() => [
            createVNode(_component_a_col, { md: 20 }, {
              default: withCtx(() => [
                createBaseVNode("div", null, [
                  createBaseVNode("div", _hoisted_10, [
                    createBaseVNode("div", _hoisted_11, [
                      _hoisted_12,
                      createBaseVNode("div", _hoisted_13, [
                        createBaseVNode("h2", _hoisted_14, toDisplayString($setup.sharedFormView.heading), 1),
                        createBaseVNode("div", _hoisted_15, toDisplayString($setup.sharedFormView.subheading), 1),
                        createBaseVNode("div", _hoisted_16, [
                          (openBlock(true), createElementBlock(Fragment, null, renderList($setup.formColumns, (field, index) => {
                            var _a, _b;
                            return openBlock(), createElementBlock("div", {
                              key: index,
                              class: "flex flex-col mt-4 px-4 space-y-2"
                            }, [
                              createBaseVNode("div", _hoisted_17, [
                                $setup.isVirtualCol(field) ? (openBlock(), createBlock(_component_SmartsheetHeaderVirtualCell, {
                                  key: 0,
                                  column: { ...field, title: field.label || field.title },
                                  required: $setup.isRequired(field, field.required),
                                  "hide-menu": true
                                }, null, 8, ["column", "required"])) : (openBlock(), createBlock(_component_SmartsheetHeaderCell, {
                                  key: 1,
                                  column: { ...field, title: field.label || field.title },
                                  required: $setup.isRequired(field, field.required),
                                  "hide-menu": true
                                }, null, 8, ["column", "required"]))
                              ]),
                              $setup.isVirtualCol(field) ? (openBlock(), createElementBlock("div", _hoisted_18, [
                                createVNode(_component_SmartsheetVirtualCell, {
                                  class: "mt-0 nc-input",
                                  column: field
                                }, null, 8, ["column"]),
                                field.description ? (openBlock(), createElementBlock("div", _hoisted_19, toDisplayString(field.description), 1)) : createCommentVNode("", true),
                                $setup.v$.virtual.$dirty && ((_a = $setup.v$.virtual) == null ? void 0 : _a[field.title]) ? (openBlock(true), createElementBlock(Fragment, { key: 1 }, renderList($setup.v$.virtual[field.title].$errors, (error) => {
                                  return openBlock(), createElementBlock("div", {
                                    key: error,
                                    class: "text-xs text-red-500"
                                  }, toDisplayString(error.$message), 1);
                                }), 128)) : createCommentVNode("", true)
                              ])) : (openBlock(), createElementBlock("div", _hoisted_20, [
                                createVNode(_component_SmartsheetCell, {
                                  modelValue: $setup.formState[field.title],
                                  "onUpdate:modelValue": ($event) => $setup.formState[field.title] = $event,
                                  class: "nc-input",
                                  column: field,
                                  "edit-enabled": true
                                }, null, 8, ["modelValue", "onUpdate:modelValue", "column"]),
                                field.description ? (openBlock(), createElementBlock("div", _hoisted_21, toDisplayString(field.description), 1)) : createCommentVNode("", true),
                                $setup.v$.localState.$dirty && ((_b = $setup.v$.localState) == null ? void 0 : _b[field.title]) ? (openBlock(true), createElementBlock(Fragment, { key: 1 }, renderList($setup.v$.localState[field.title].$errors, (error) => {
                                  return openBlock(), createElementBlock("div", {
                                    key: error,
                                    class: "text-xs text-red-500"
                                  }, toDisplayString(error.$message), 1);
                                }), 128)) : createCommentVNode("", true)
                              ]))
                            ]);
                          }), 128)),
                          createBaseVNode("div", _hoisted_22, [
                            createVNode(_component_a_button, {
                              type: "primary",
                              size: "large",
                              onClick: _cache[1] || (_cache[1] = ($event) => $setup.submitForm($setup.formState, _ctx.additionalState))
                            }, {
                              default: withCtx(() => [
                                _hoisted_23
                              ]),
                              _: 1
                            })
                          ])
                        ])
                      ])
                    ])
                  ])
                ])
              ]),
              _: 1
            })
          ]),
          _: 1
        })
      ])) : createCommentVNode("", true)
    ]),
    createVNode(_component_a_modal, {
      visible: $setup.passwordDlg,
      "onUpdate:visible": _cache[3] || (_cache[3] = ($event) => $setup.passwordDlg = $event),
      closable: false,
      width: "28rem",
      centered: "",
      footer: null,
      "mask-closable": false,
      onClose: _cache[4] || (_cache[4] = ($event) => $setup.passwordDlg = false)
    }, {
      default: withCtx(() => [
        createBaseVNode("div", _hoisted_24, [
          createVNode(_component_a_typography_title, { level: 4 }, {
            default: withCtx(() => [
              _hoisted_25
            ]),
            _: 1
          }),
          createVNode(_component_a_form, {
            ref: "formRef",
            model: { password: $setup.password },
            class: "mt-2",
            onFinish: $setup.loadSharedView
          }, {
            default: withCtx(() => [
              createVNode(_component_a_form_item, {
                name: "password",
                rules: [{ required: true, message: "Password is required" }]
              }, {
                default: withCtx(() => [
                  createVNode(_component_a_input_password, {
                    value: $setup.password,
                    "onUpdate:value": _cache[2] || (_cache[2] = ($event) => $setup.password = $event),
                    placeholder: "Enter password"
                  }, null, 8, ["value"])
                ]),
                _: 1
              }),
              createVNode(_component_a_button, {
                type: "primary",
                "html-type": "submit"
              }, {
                default: withCtx(() => [
                  _hoisted_26
                ]),
                _: 1
              })
            ]),
            _: 1
          }, 8, ["model", "onFinish"])
        ])
      ]),
      _: 1
    }, 8, ["visible"])
  ]);
}
var __nuxt_component_0 = /* @__PURE__ */ _export_sfc(_sfc_main$1, [["render", _sfc_render$1], ["__scopeId", "data-v-16a75d8b"]]);
const _sfc_main = /* @__PURE__ */ defineComponent({
  __name: "[viewId]",
  async setup(__props, { expose }) {
    expose();
    let __temp, __restore;
    const route = useRoute();
    const reloadEventHook = createEventHook();
    const { loadSharedView, sharedView, meta, notFound } = useProvideSharedFormStore(route.params.viewId);
    [__temp, __restore] = withAsyncContext(() => loadSharedView()), await __temp, __restore();
    if (!notFound.value) {
      provide(ReloadViewDataHookInj, reloadEventHook);
      provide(MetaInj, meta);
      provide(IsPublicInj, ref(true));
      provide(IsFormInj, ref(true));
      useProvideSmartsheetStore(sharedView, meta, true);
    }
    const __returned__ = { route, reloadEventHook, loadSharedView, sharedView, meta, notFound };
    Object.defineProperty(__returned__, "__isScriptSetup", { enumerable: false, value: true });
    return __returned__;
  }
});
function _sfc_render(_ctx, _cache, $props, $setup, $data, $options) {
  const _component_SharedViewForm = __nuxt_component_0;
  return openBlock(), createBlock(_component_SharedViewForm);
}
var _viewId_ = /* @__PURE__ */ _export_sfc(_sfc_main, [["render", _sfc_render]]);
export { _viewId_ as default };
