import { _ as __nuxt_component_0 } from "./NocoIcon-d738cc24.mjs";
import { _ as _export_sfc, d as defineComponent, u as useNuxtApp, a5 as useApi, t as reactive, r as ref, x as onMounted, a9 as nextTick, o as openBlock, l as createBlock, k as withCtx, n as Card, j as createVNode, b as createBaseVNode, z as toDisplayString, E as createTextVNode, dZ as projectTitleValidator, dG as navigateTo, $ as message, a2 as extractSdkResponseErrorMsg, W as Input, X as __unplugin_components_2, O as Button, Y as Form } from "./entry-3ffd12c8.mjs";
import { u as useSidebar } from "./index-75f7d1ec.mjs";
import { _ as __unplugin_components_4 } from "./rocket-launch-outline-8b24fa22.mjs";
const _sfc_main = /* @__PURE__ */ defineComponent({
  __name: "create",
  setup(__props, { expose }) {
    expose();
    const { $e } = useNuxtApp();
    const { api, isLoading } = useApi();
    useSidebar({ hasSidebar: false });
    const nameValidationRules = [
      {
        required: true,
        message: "Project name is required"
      },
      projectTitleValidator
    ];
    const formState = reactive({
      title: ""
    });
    const createProject = async () => {
      $e("a:project:create:xcdb");
      try {
        const result = await api.project.create({
          title: formState.title
        });
        await navigateTo(`/nc/${result.id}`);
      } catch (e) {
        message.error(await extractSdkResponseErrorMsg(e));
      }
    };
    const form = ref();
    onMounted(async () => {
      await nextTick(() => {
        setTimeout(() => {
          var _a, _b;
          const input = (_b = (_a = form.value) == null ? void 0 : _a.$el) == null ? void 0 : _b.querySelector("input[type=text]");
          input.setSelectionRange(0, formState.title.length);
          input.focus();
        }, 500);
      });
    });
    const __returned__ = { $e, api, isLoading, nameValidationRules, formState, createProject, form, MaterialSymbolsRocketLaunchOutline: __unplugin_components_4 };
    Object.defineProperty(__returned__, "__isScriptSetup", { enumerable: false, value: true });
    return __returned__;
  }
});
const _hoisted_1 = { class: "text-3xl text-center font-semibold mt-8 mb-2" };
const _hoisted_2 = { class: "flex items-center" };
function _sfc_render(_ctx, _cache, $props, $setup, $data, $options) {
  const _component_GeneralNocoIcon = __nuxt_component_0;
  const _component_a_input = Input;
  const _component_a_form_item = __unplugin_components_2;
  const _component_a_button = Button;
  const _component_a_form = Form;
  const _component_a_card = Card;
  return openBlock(), createBlock(_component_a_card, {
    loading: $setup.isLoading,
    class: "w-[500px] !mx-auto !mt-100px shadow-md"
  }, {
    default: withCtx(() => [
      createVNode(_component_GeneralNocoIcon),
      createBaseVNode("h3", _hoisted_1, toDisplayString(_ctx.$t("activity.createProject")), 1),
      createVNode(_component_a_form, {
        ref: "form",
        model: $setup.formState,
        name: "basic",
        layout: "vertical",
        autocomplete: "off",
        onFinish: $setup.createProject
      }, {
        default: withCtx(() => [
          createVNode(_component_a_form_item, {
            label: _ctx.$t("labels.projName"),
            name: "title",
            rules: $setup.nameValidationRules,
            class: "my-10 mx-10"
          }, {
            default: withCtx(() => [
              createVNode(_component_a_input, {
                value: $setup.formState.title,
                "onUpdate:value": _cache[0] || (_cache[0] = ($event) => $setup.formState.title = $event),
                name: "title",
                class: "nc-metadb-project-name"
              }, null, 8, ["value"])
            ]),
            _: 1
          }, 8, ["label"]),
          createVNode(_component_a_form_item, {
            style: { "text-align": "center" },
            class: "mt-2"
          }, {
            default: withCtx(() => [
              createVNode(_component_a_button, {
                type: "primary",
                "html-type": "submit"
              }, {
                default: withCtx(() => [
                  createBaseVNode("div", _hoisted_2, [
                    createVNode($setup["MaterialSymbolsRocketLaunchOutline"], { class: "mr-1" }),
                    createTextVNode(" " + toDisplayString(_ctx.$t("general.create")), 1)
                  ])
                ]),
                _: 1
              })
            ]),
            _: 1
          })
        ]),
        _: 1
      }, 8, ["model"])
    ]),
    _: 1
  }, 8, ["loading"]);
}
var create = /* @__PURE__ */ _export_sfc(_sfc_main, [["render", _sfc_render]]);
export { create as default };
