import { _ as _export_sfc, d as defineComponent, f as computed, o as openBlock, c as createElementBlock, H as normalizeClass, D as withModifiers, b as createBaseVNode, ae as normalizeStyle, B as createCommentVNode, a4 as useI18n, y as resolveDirective, l as createBlock, J as withDirectives, j as createVNode, dO as MdiDiscord, dN as MdiCalendarMonth, L as pushScopeId, N as popScopeId, ak as useRoute, u as useNuxtApp, cT as withAsyncContext, r as ref, cF as resolveComponent, k as withCtx, dG as navigateTo, T as MdiPlus, dH as __nuxt_component_2, E as createTextVNode, z as toDisplayString, h as renderList, ad as resolveDynamicComponent, g as Fragment, aa as Modal, $ as message, a2 as extractSdkResponseErrorMsg, ai as __unplugin_components_0, am as Menu, aL as __unplugin_components_2 } from "./entry-3ffd12c8.mjs";
import { M as MdiTwitter, _ as __nuxt_component_1 } from "./Sponsors-76711a53.mjs";
import { M as MdiDatabaseOutline } from "./database-outline-41b305ba.mjs";
import "./index-9b24011f.mjs";
const _sfc_main$2 = /* @__PURE__ */ defineComponent({
  __name: "Share",
  props: {
    url: null,
    socialMedias: null,
    title: { default: "NocoDB" },
    summary: null,
    hashTags: { default: "" },
    css: { default: "" },
    iconClass: { default: "" },
    width: { default: "45px" }
  },
  setup(__props, { expose }) {
    expose();
    const summaryArr = [
      "Instant #Rest & #GraphQL APIs on any #SQL Database (Supports : MySQL, PostgresSQL, MsSQL, SQLite, MariaDB) #nocodb ",
      "Instantly generate #Rest & #GraphQL APIs on any #SQL Database (Supports : MySQL, PostgresSQL, MsSQL, SQLite, MariaDB) #nocodb",
      "Instant #serverless Rest & #GraphQL APIs on any Database #nocodb",
      "Instant APIs on any SQL Database (Supports : #REST #GraphQL #MySQL, #PostgresSQL, #MsSQL, #SQLite, #MariaDB) #nocodb",
      "Generate Instant APIs on any SQL Database (Supports : #REST #GraphQL #MySQL, #PostgresSQL, #MsSQL, #SQLite, #MariaDB) #nocodb"
    ];
    const shareUrl = computed(() => encodeURIComponent(__props.url));
    const encodedTitle = computed(() => encodeURIComponent(__props.title || "NocoDB"));
    const encodedSummary = computed(() => encodeURIComponent(__props.summary || summaryArr[Math.floor(Math.random() * summaryArr.length)]));
    const fbHashTags = computed(() => __props.hashTags && `%23${__props.hashTags}`);
    const openUrl = (url) => {
      window.open(url, "_blank");
    };
    const __returned__ = { summaryArr, shareUrl, encodedTitle, encodedSummary, fbHashTags, openUrl };
    Object.defineProperty(__returned__, "__isScriptSetup", { enumerable: false, value: true });
    return __returned__;
  }
});
const _hoisted_1$6 = { class: "flex gap-2" };
const _hoisted_2$6 = ["width"];
const _hoisted_3$6 = ["width"];
const _hoisted_4$1 = ["width"];
const _hoisted_5$1 = ["width"];
const _hoisted_6$1 = ["width"];
const _hoisted_7$1 = ["width"];
const _hoisted_8$1 = ["width"];
const _hoisted_9$1 = ["width"];
const _hoisted_10$1 = ["width"];
const _hoisted_11$1 = ["width"];
const _hoisted_12 = ["width"];
const _hoisted_13 = ["width"];
const _hoisted_14 = ["width"];
const _hoisted_15 = ["width"];
const _hoisted_16 = ["width"];
function _sfc_render$2(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(), createElementBlock("div", _hoisted_1$6, [
    !$props.socialMedias || !$props.socialMedias.length || $props.socialMedias.includes("twitter") ? (openBlock(), createElementBlock("a", {
      key: 0,
      href: "#",
      class: normalizeClass([$props.iconClass, "px-2"]),
      onClick: _cache[0] || (_cache[0] = withModifiers(($event) => $setup.openUrl(`https://twitter.com/intent/tweet?url=${$setup.shareUrl}&text=${$setup.encodedSummary}&hashtags=${$props.hashTags}`), ["prevent"]))
    }, [
      createBaseVNode("img", {
        src: "/social/twitter.png",
        class: "img-responsive",
        alt: "Twitter",
        width: $props.width,
        style: normalizeStyle($props.css),
        title: "Social Media Share"
      }, null, 12, _hoisted_2$6)
    ], 2)) : createCommentVNode("", true),
    !$props.socialMedias || !$props.socialMedias.length || $props.socialMedias.includes("linkedin") ? (openBlock(), createElementBlock("a", {
      key: 1,
      href: "#",
      class: normalizeClass([$props.iconClass, "px-2"]),
      onClick: _cache[1] || (_cache[1] = withModifiers(($event) => $setup.openUrl(`https://www.linkedin.com/shareArticle?mini=true&url=${$setup.shareUrl}&title=${$setup.encodedTitle}&summary=${$setup.encodedSummary}`), ["prevent"]))
    }, [
      createBaseVNode("img", {
        src: "/social/linkedin.png",
        class: "img-responsive",
        alt: "Linkedin",
        width: $props.width,
        style: normalizeStyle($props.css),
        title: "Social Media Share"
      }, null, 12, _hoisted_3$6)
    ], 2)) : createCommentVNode("", true),
    !$props.socialMedias || !$props.socialMedias.length || $props.socialMedias.includes("facebook") ? (openBlock(), createElementBlock("a", {
      key: 2,
      href: "#",
      class: normalizeClass([$props.iconClass, "px-2"]),
      onClick: _cache[2] || (_cache[2] = withModifiers(($event) => $setup.openUrl(`https://www.facebook.com/sharer/sharer.php?u=${$setup.shareUrl}&title=${$setup.encodedTitle}&summary=${$setup.encodedSummary}&quote=${$setup.encodedTitle}&hashtag=${$setup.fbHashTags}`), ["prevent"]))
    }, [
      createBaseVNode("img", {
        src: "/social/facebook.png",
        class: "img-responsive",
        alt: "Facebook",
        width: $props.width,
        style: normalizeStyle($props.css),
        title: "Social Media Share"
      }, null, 12, _hoisted_4$1)
    ], 2)) : createCommentVNode("", true),
    !$props.socialMedias || !$props.socialMedias.length || $props.socialMedias.includes("reddit") ? (openBlock(), createElementBlock("a", {
      key: 3,
      href: "#",
      class: normalizeClass([$props.iconClass, "px-2"]),
      onClick: _cache[3] || (_cache[3] = withModifiers(($event) => $setup.openUrl(`https://www.reddit.com/submit?url=${$setup.shareUrl}&title=${$setup.encodedSummary}`), ["prevent"]))
    }, [
      createBaseVNode("img", {
        src: "/social/reddit.png",
        class: "img-responsive",
        alt: "Reddit",
        width: $props.width,
        style: normalizeStyle($props.css),
        title: "Social Media Share"
      }, null, 12, _hoisted_5$1)
    ], 2)) : createCommentVNode("", true),
    !$props.socialMedias || !$props.socialMedias.length || $props.socialMedias.includes("pinterest") ? (openBlock(), createElementBlock("a", {
      key: 4,
      href: "#",
      class: normalizeClass([$props.iconClass, "px-2"]),
      onClick: _cache[4] || (_cache[4] = withModifiers(($event) => $setup.openUrl(`https://pinterest.com/pin/create/button/?url=${$setup.shareUrl}&description==${$setup.encodedSummary}`), ["prevent"]))
    }, [
      createBaseVNode("img", {
        src: "/social/pinterest.png",
        class: "img-responsive",
        alt: "Printrest",
        width: $props.width,
        style: normalizeStyle($props.css),
        title: "Social Media Share"
      }, null, 12, _hoisted_6$1)
    ], 2)) : createCommentVNode("", true),
    !$props.socialMedias || !$props.socialMedias.length || $props.socialMedias.includes("whatsapp") ? (openBlock(), createElementBlock("a", {
      key: 5,
      href: "#",
      class: normalizeClass([$props.iconClass, "px-2"]),
      onClick: _cache[5] || (_cache[5] = withModifiers(($event) => $setup.openUrl(`https://api.whatsapp.com/send?text=${$setup.encodedSummary}%0D%0A${$setup.shareUrl}`), ["prevent"]))
    }, [
      createBaseVNode("img", {
        src: "/social/whatsapp.png",
        class: "img-responsive",
        alt: "Whatsapp",
        width: $props.width,
        style: normalizeStyle($props.css),
        title: "Social Media Share"
      }, null, 12, _hoisted_7$1)
    ], 2)) : createCommentVNode("", true),
    !$props.socialMedias || !$props.socialMedias.length || $props.socialMedias.includes("telegram") ? (openBlock(), createElementBlock("a", {
      key: 6,
      href: "#",
      class: normalizeClass([$props.iconClass, "px-2"]),
      onClick: _cache[6] || (_cache[6] = withModifiers(($event) => $setup.openUrl(`https://telegram.me/share/url?url=${$setup.shareUrl}&text=${$setup.encodedSummary}`), ["prevent"]))
    }, [
      createBaseVNode("img", {
        src: "/social/png/telegram.png",
        class: "img-responsive",
        alt: "Telegram",
        width: $props.width,
        style: normalizeStyle($props.css),
        title: "Social Media Share"
      }, null, 12, _hoisted_8$1)
    ], 2)) : createCommentVNode("", true),
    !$props.socialMedias || !$props.socialMedias.length || $props.socialMedias.includes("wechat") ? (openBlock(), createElementBlock("a", {
      key: 7,
      class: normalizeClass([$props.iconClass, "px-2"]),
      onClick: _cache[7] || (_cache[7] = withModifiers(($event) => $setup.openUrl(`https://www.addtoany.com/add_to/wechat?linkurl=${$setup.shareUrl}&linkname=${$setup.encodedTitle}`), ["prevent"]))
    }, [
      createBaseVNode("img", {
        src: "/social/png/wechat.png",
        class: "img-responsive",
        alt: "Wechat",
        width: $props.width,
        style: normalizeStyle($props.css),
        title: "Social Media Share"
      }, null, 12, _hoisted_9$1)
    ], 2)) : createCommentVNode("", true),
    !$props.socialMedias || !$props.socialMedias.length || $props.socialMedias.includes("line") ? (openBlock(), createElementBlock("a", {
      key: 8,
      href: "#",
      class: normalizeClass([$props.iconClass, "px-2"])
    }, [
      createBaseVNode("img", {
        src: "/social/png/line.png",
        class: "img-responsive",
        alt: "Line",
        width: $props.width,
        style: normalizeStyle($props.css),
        title: "Social Media Share",
        onClick: _cache[8] || (_cache[8] = withModifiers(($event) => $setup.openUrl(`http://line.me/R/msg/text/?${$setup.encodedTitle}%0D%0A${$setup.shareUrl}`), ["prevent"]))
      }, null, 12, _hoisted_10$1)
    ], 2)) : createCommentVNode("", true),
    !$props.socialMedias || !$props.socialMedias.length || $props.socialMedias.includes("odnoklassniki") ? (openBlock(), createElementBlock("a", {
      key: 9,
      href: "#",
      class: normalizeClass([$props.iconClass, "px-2"])
    }, [
      createBaseVNode("img", {
        src: "/social/png/odnoklassniki.png",
        class: "img-responsive",
        alt: "Odnoklassniki",
        width: $props.width,
        style: normalizeStyle($props.css),
        title: "Social Media Share",
        onClick: _cache[9] || (_cache[9] = withModifiers(($event) => $setup.openUrl(`https://connect.ok.ru/dk?st.cmd=WidgetSharePreview&st.shareUrl=${$setup.shareUrl}&st.comments=${$setup.encodedSummary}`), ["prevent"]))
      }, null, 12, _hoisted_11$1)
    ], 2)) : createCommentVNode("", true),
    !$props.socialMedias || !$props.socialMedias.length || $props.socialMedias.includes("weibo") ? (openBlock(), createElementBlock("a", {
      key: 10,
      href: "#",
      class: normalizeClass([$props.iconClass, "px-2"]),
      onClick: _cache[10] || (_cache[10] = withModifiers(($event) => $setup.openUrl(`http://service.weibo.com/share/share.php?url=${$setup.shareUrl})&title=${$setup.encodedTitle}`), ["prevent"]))
    }, [
      createBaseVNode("img", {
        src: "/social/png/weibo.png",
        class: "img-responsive",
        alt: "Weibo",
        width: $props.width,
        style: normalizeStyle($props.css),
        title: "Social Media Share"
      }, null, 12, _hoisted_12)
    ], 2)) : createCommentVNode("", true),
    !$props.socialMedias || !$props.socialMedias.length || $props.socialMedias.includes("renren") ? (openBlock(), createElementBlock("a", {
      key: 11,
      class: normalizeClass([$props.iconClass, "px-2"]),
      onClick: _cache[11] || (_cache[11] = withModifiers(($event) => $setup.openUrl(`http://widget.renren.com/dialog/share?resourceUrl=${$setup.shareUrl}&srcUrl=${$setup.shareUrl}&title=${$setup.encodedTitle}&description=${$setup.encodedSummary}`), ["prevent"]))
    }, [
      createBaseVNode("img", {
        src: "/social/png/renren.png",
        class: "img-responsive",
        alt: "Renren",
        width: $props.width,
        style: normalizeStyle($props.css),
        title: "Social Media Share"
      }, null, 12, _hoisted_13)
    ], 2)) : createCommentVNode("", true),
    !$props.socialMedias || !$props.socialMedias.length || $props.socialMedias.includes("douban") ? (openBlock(), createElementBlock("a", {
      key: 12,
      class: normalizeClass([$props.iconClass, "px-2"]),
      onClick: _cache[12] || (_cache[12] = withModifiers(($event) => $setup.openUrl(`http://www.douban.com/recommend/?url=${$setup.shareUrl}&title=${$setup.encodedTitle}`), ["prevent"]))
    }, [
      createBaseVNode("img", {
        src: "/social/png/douban.png",
        class: "img-responsive",
        alt: "Douban",
        width: $props.width,
        style: normalizeStyle($props.css),
        title: "Social Media Share"
      }, null, 12, _hoisted_14)
    ], 2)) : createCommentVNode("", true),
    !$props.socialMedias || !$props.socialMedias.length || $props.socialMedias.includes("vk") ? (openBlock(), createElementBlock("a", {
      key: 13,
      href: "#",
      class: normalizeClass([$props.iconClass, "px-2"]),
      onClick: _cache[13] || (_cache[13] = withModifiers(($event) => $setup.openUrl(`https://vk.com/share.php?url=${$setup.shareUrl})&title=${$setup.encodedTitle}&description=${$setup.encodedSummary}&noparse=true`), ["prevent"]))
    }, [
      createBaseVNode("img", {
        src: "/social/png/vk.png",
        class: "img-responsive",
        alt: "VK",
        width: $props.width,
        style: normalizeStyle($props.css),
        title: "Social Media Share"
      }, null, 12, _hoisted_15)
    ], 2)) : createCommentVNode("", true),
    !$props.socialMedias || !$props.socialMedias.length || $props.socialMedias.includes("wykop") ? (openBlock(), createElementBlock("a", {
      key: 14,
      class: normalizeClass([$props.iconClass, "px-2"]),
      onClick: _cache[14] || (_cache[14] = withModifiers(($event) => $setup.openUrl(`https://www.addtoany.com/add_to/wykop?linkurl=${$setup.shareUrl}&linkname=${$setup.encodedTitle}`), ["prevent"]))
    }, [
      createBaseVNode("img", {
        src: "/social/png/wykop.jpg",
        class: "img-responsive",
        alt: "Wykop",
        width: $props.width,
        style: normalizeStyle($props.css),
        title: "Social Media Share"
      }, null, 12, _hoisted_16)
    ], 2)) : createCommentVNode("", true)
  ]);
}
var __nuxt_component_0$1 = /* @__PURE__ */ _export_sfc(_sfc_main$2, [["render", _sfc_render$2], ["__scopeId", "data-v-4984ddec"]]);
const _hoisted_1$5 = {
  class: "nc-icon",
  preserveAspectRatio: "xMidYMid meet",
  viewBox: "0 0 24 24",
  width: "1.2em",
  height: "1.2em"
};
const _hoisted_2$5 = /* @__PURE__ */ createBaseVNode("path", {
  fill: "currentColor",
  d: "M14.5 15.41c.08.09.08.28 0 .39c-.73.7-2.09.76-2.5.76c-.39 0-1.75-.06-2.46-.76c-.1-.11-.1-.3 0-.39c.11-.1.28-.1.38 0c.46.46 1.41.59 2.08.59c.69 0 1.66-.13 2.1-.59c.11-.1.28-.1.4 0m-3.75-2.37c0-.57-.47-1.04-1.04-1.04c-.57 0-1.04.47-1.04 1.04c0 .57.47 1.05 1.04 1.04c.57 0 1.04-.47 1.04-1.04M14.29 12c-.57 0-1.04.5-1.04 1.05s.47 1.04 1.04 1.04c.57 0 1.04-.48 1.04-1.04c0-.55-.47-1.05-1.04-1.05M22 12c0 5.5-4.5 10-10 10S2 17.5 2 12S6.5 2 12 2s10 4.5 10 10m-3.33 0c0-.81-.67-1.46-1.45-1.46c-.4 0-.76.16-1.02.41c-1-.72-2.37-1.18-3.9-1.24l.67-3.13l2.17.47c.02.55.48.99 1.04.99c.57 0 1.04-.47 1.04-1.04c0-.57-.47-1.04-1.04-1.04c-.41 0-.77.24-.93.59l-2.43-.52c-.07-.03-.14 0-.19.04c-.06.04-.09.1-.1.17l-.74 3.48c-1.55.05-2.95.51-3.97 1.24c-.26-.25-.62-.4-1.01-.4c-.81 0-1.46.65-1.46 1.44c0 .61.36 1.11.86 1.34c-.02.16-.03.28-.03.44c0 2.22 2.61 4.07 5.82 4.07c3.23 0 5.85-1.82 5.85-4.07c0-.14-.01-.28-.04-.44c.5-.23.86-.74.86-1.34Z"
}, null, -1);
const _hoisted_3$5 = [
  _hoisted_2$5
];
function render$3(_ctx, _cache) {
  return openBlock(), createElementBlock("svg", _hoisted_1$5, _hoisted_3$5);
}
var MdiReddit = { name: "mdi-reddit", render: render$3 };
const _sfc_main$1 = /* @__PURE__ */ defineComponent({
  __name: "Social",
  setup(__props, { expose }) {
    expose();
    const { locale } = useI18n();
    const open = (url) => {
      window.open(url, "_blank");
    };
    const isZhLang = computed(() => locale.value.startsWith("zh"));
    const __returned__ = { locale, open, isZhLang, MdiDiscord, MdiReddit, MdiTwitter, MdiCalendarMonth };
    Object.defineProperty(__returned__, "__isScriptSetup", { enumerable: false, value: true });
    return __returned__;
  }
});
const _withScopeId = (n) => (pushScopeId("data-v-5ce17f9c"), n = n(), popScopeId(), n);
const _hoisted_1$4 = {
  key: 1,
  class: "flex justify-between gap-1 w-full px-2"
};
const _hoisted_2$4 = /* @__PURE__ */ _withScopeId(() => /* @__PURE__ */ createBaseVNode("div", { class: "discourse" }, null, -1));
const _hoisted_3$4 = [
  _hoisted_2$4
];
function _sfc_render$1(_ctx, _cache, $props, $setup, $data, $options) {
  const _component_general_share = __nuxt_component_0$1;
  const _directive_t = resolveDirective("t");
  return $setup.isZhLang ? (openBlock(), createBlock(_component_general_share, {
    key: 0,
    class: "flex justify-center",
    url: "https://github.com/nocodb/nocodb",
    "social-medias": ["renren", "douban", "weibo", "wechat"]
  })) : (openBlock(), createElementBlock("div", _hoisted_1$4, [
    withDirectives(createVNode($setup["MdiDiscord"], {
      class: "icon text-[#7289DA]",
      onClick: _cache[0] || (_cache[0] = ($event) => $setup.open("https://discord.gg/5RgZmkW"))
    }, null, 512), [
      [_directive_t, ["e:community:discord"]]
    ]),
    withDirectives((openBlock(), createElementBlock("div", {
      class: "icon flex items-center justify-center min-w-[43px]",
      onClick: _cache[1] || (_cache[1] = ($event) => $setup.open("https://community.nocodb.com/"))
    }, _hoisted_3$4)), [
      [_directive_t, ["e:community:discourse"]]
    ]),
    withDirectives(createVNode($setup["MdiReddit"], {
      class: "icon text-[#FF4600]",
      onClick: _cache[2] || (_cache[2] = ($event) => $setup.open("https://www.reddit.com/r/NocoDB/"))
    }, null, 512), [
      [_directive_t, ["e:community:reddit"]]
    ]),
    withDirectives(createVNode($setup["MdiTwitter"], {
      class: "icon text-[#1DA1F2]",
      onClick: _cache[3] || (_cache[3] = ($event) => $setup.open("https://twitter.com/NocoDB"))
    }, null, 512), [
      [_directive_t, ["e:community:twitter"]]
    ]),
    withDirectives(createVNode($setup["MdiCalendarMonth"], {
      class: "icon text-green-500",
      onClick: _cache[4] || (_cache[4] = ($event) => $setup.open("https://calendly.com/nocodb-meeting"))
    }, null, 512), [
      [_directive_t, ["e:community:book-demo"]]
    ])
  ]));
}
var __nuxt_component_0 = /* @__PURE__ */ _export_sfc(_sfc_main$1, [["render", _sfc_render$1], ["__scopeId", "data-v-5ce17f9c"]]);
const _hoisted_1$3 = {
  class: "nc-icon",
  preserveAspectRatio: "xMidYMid meet",
  viewBox: "0 0 24 24",
  width: "1.2em",
  height: "1.2em"
};
const _hoisted_2$3 = /* @__PURE__ */ createBaseVNode("path", {
  fill: "currentColor",
  d: "M4.5 13.5q-.625 0-1.062-.438Q3 12.625 3 12t.438-1.062Q3.875 10.5 4.5 10.5t1.062.438Q6 11.375 6 12t-.438 1.062q-.437.438-1.062.438Zm0-6q-.625 0-1.062-.438Q3 6.625 3 6t.438-1.062Q3.875 4.5 4.5 4.5t1.062.438Q6 5.375 6 6t-.438 1.062Q5.125 7.5 4.5 7.5Zm0 12q-.625 0-1.062-.438Q3 18.625 3 18t.438-1.062Q3.875 16.5 4.5 16.5t1.062.438Q6 17.375 6 18t-.438 1.062q-.437.438-1.062.438ZM9 19q-.425 0-.712-.288Q8 18.425 8 18t.288-.712Q8.575 17 9 17h11q.425 0 .712.288q.288.287.288.712t-.288.712Q20.425 19 20 19Zm0-6q-.425 0-.712-.288Q8 12.425 8 12t.288-.713Q8.575 11 9 11h11q.425 0 .712.287q.288.288.288.713t-.288.712Q20.425 13 20 13Zm0-6q-.425 0-.712-.287Q8 6.425 8 6t.288-.713Q8.575 5 9 5h11q.425 0 .712.287Q21 5.575 21 6t-.288.713Q20.425 7 20 7Z"
}, null, -1);
const _hoisted_3$3 = [
  _hoisted_2$3
];
function render$2(_ctx, _cache) {
  return openBlock(), createElementBlock("svg", _hoisted_1$3, _hoisted_3$3);
}
var MaterialSymbolsFormatListBulletedRounded = { name: "material-symbols-format-list-bulleted-rounded", render: render$2 };
const _hoisted_1$2 = {
  class: "nc-icon",
  preserveAspectRatio: "xMidYMid meet",
  viewBox: "0 0 24 24",
  width: "1.2em",
  height: "1.2em"
};
const _hoisted_2$2 = /* @__PURE__ */ createBaseVNode("path", {
  fill: "currentColor",
  d: "M3 11V3h8v8Zm0 10v-8h8v8Zm10-10V3h8v8Zm0 10v-8h8v8Z"
}, null, -1);
const _hoisted_3$2 = [
  _hoisted_2$2
];
function render$1(_ctx, _cache) {
  return openBlock(), createElementBlock("svg", _hoisted_1$2, _hoisted_3$2);
}
var MaterialSymbolsGridView = { name: "material-symbols-grid-view", render: render$1 };
const _hoisted_1$1 = {
  class: "nc-icon",
  preserveAspectRatio: "xMidYMid meet",
  viewBox: "0 0 24 24",
  width: "1.2em",
  height: "1.2em"
};
const _hoisted_2$1 = /* @__PURE__ */ createBaseVNode("path", {
  fill: "currentColor",
  d: "M20 18H4V8h16m0-2h-8l-2-2H4c-1.11 0-2 .89-2 2v12a2 2 0 0 0 2 2h16a2 2 0 0 0 2-2V8a2 2 0 0 0-2-2Z"
}, null, -1);
const _hoisted_3$1 = [
  _hoisted_2$1
];
function render(_ctx, _cache) {
  return openBlock(), createElementBlock("svg", _hoisted_1$1, _hoisted_3$1);
}
var MdiFolderOutline = { name: "mdi-folder-outline", render };
const _sfc_main = /* @__PURE__ */ defineComponent({
  __name: "index",
  async setup(__props, { expose }) {
    expose();
    let __temp, __restore;
    const navDrawerOptions = [
      {
        title: "My NocoDB",
        icon: MdiFolderOutline
      }
    ];
    const route = useRoute();
    const { $api } = useNuxtApp();
    const response = ([__temp, __restore] = withAsyncContext(() => $api.project.list({})), __temp = await __temp, __restore(), __temp);
    const projects = ref(response.list);
    const activePage = ref(navDrawerOptions[0].title);
    const deleteProject = (project) => {
      Modal.confirm({
        title: "Do you want to delete the project?",
        content: "Some descriptions",
        okText: "Yes",
        okType: "danger",
        cancelText: "No",
        async onOk() {
          try {
            await $api.project.delete(project.id);
            projects.value.splice(projects.value.indexOf(project), 1);
          } catch (e) {
            message.error(await extractSdkResponseErrorMsg(e));
          }
        }
      });
    };
    const __returned__ = { navDrawerOptions, route, $api, response, projects, activePage, deleteProject, navigateTo, MaterialSymbolsFormatListBulletedRounded, MaterialSymbolsGridView, MdiPlus, MdiDatabaseOutline };
    Object.defineProperty(__returned__, "__isScriptSetup", { enumerable: false, value: true });
    return __returned__;
  }
});
const _hoisted_1 = { class: "flex flex-col h-full" };
const _hoisted_2 = { class: "flex p-4" };
const _hoisted_3 = ["onClick"];
const _hoisted_4 = { class: "col-span-10 text-sm xl:text-md" };
const _hoisted_5 = ["innerHTML"];
const _hoisted_6 = { class: "flex items-center gap-4" };
const _hoisted_7 = { class: "font-semibold" };
const _hoisted_8 = { class: "flex-1 mb-12" };
const _hoisted_9 = { class: "flex" };
const _hoisted_10 = { class: "flex-1 text-2xl md:text-4xl font-bold text-gray-500 p-4" };
const _hoisted_11 = { class: "self-end flex text-4xl mb-1" };
function _sfc_render(_ctx, _cache, $props, $setup, $data, $options) {
  const _component_v_list = resolveComponent("v-list");
  const _component_v_menu = resolveComponent("v-menu");
  const _component_a_menu_item = __unplugin_components_0;
  const _component_a_menu = Menu;
  const _component_general_social = __nuxt_component_0;
  const _component_general_sponsors = __nuxt_component_1;
  const _component_a_divider = __unplugin_components_2;
  const _component_NuxtPage = resolveComponent("NuxtPage");
  const _component_a_modal = Modal;
  const _component_NuxtLayout = __nuxt_component_2;
  return openBlock(), createBlock(_component_NuxtLayout, null, {
    sidebar: withCtx(() => [
      createBaseVNode("div", _hoisted_1, [
        createBaseVNode("div", _hoisted_2, [
          createVNode(_component_v_menu, { class: "select-none" }, {
            activator: withCtx(({ props }) => [
              createBaseVNode("div", {
                class: "color-transition hover:bg-gray-100 mr-auto select-none flex items-center gap-2 leading-8 cursor-pointer rounded-full border-1 border-gray-300 px-5 py-2 shadow prose-lg font-semibold",
                onClick: props.onClick
              }, [
                createVNode($setup["MdiPlus"], { class: "text-primary text-2xl" }),
                createTextVNode(" " + toDisplayString(_ctx.$t("title.newProj")), 1)
              ], 8, _hoisted_3)
            ]),
            default: withCtx(() => [
              createVNode(_component_v_list, { class: "!py-0 flex flex-col bg-white rounded-lg shadow-md border-1 border-gray-300 mt-2 ml-2" }, {
                default: withCtx(() => [
                  createBaseVNode("div", {
                    class: "grid grid-cols-12 cursor-pointer hover:bg-gray-200 flex items-center p-2",
                    onClick: _cache[0] || (_cache[0] = ($event) => $setup.navigateTo("/project/create"))
                  }, [
                    createVNode($setup["MdiPlus"], { class: "col-span-2 mr-1 mt-[1px] text-primary text-lg" }),
                    createBaseVNode("div", _hoisted_4, toDisplayString(_ctx.$t("activity.createProject")), 1)
                  ]),
                  createBaseVNode("div", {
                    class: "grid grid-cols-12 cursor-pointer hover:bg-gray-200 flex items-center p-2",
                    onClick: _cache[1] || (_cache[1] = ($event) => $setup.navigateTo("/project/create-external"))
                  }, [
                    createVNode($setup["MdiDatabaseOutline"], { class: "col-span-2 mr-1 mt-[1px] text-green-500 text-lg" }),
                    createBaseVNode("div", {
                      class: "col-span-10 text-sm xl:text-md",
                      innerHTML: _ctx.$t("activity.createProjectExtended.extDB")
                    }, null, 8, _hoisted_5)
                  ])
                ]),
                _: 1
              })
            ]),
            _: 1
          })
        ]),
        createVNode(_component_a_menu, { class: "pr-4 flex-1 border-0" }, {
          default: withCtx(() => [
            (openBlock(), createElementBlock(Fragment, null, renderList($setup.navDrawerOptions, (option, index2) => {
              return createVNode(_component_a_menu_item, {
                key: index2,
                class: "!rounded-r-lg",
                onClick: ($event) => $setup.activePage = option.title
              }, {
                default: withCtx(() => [
                  createBaseVNode("div", _hoisted_6, [
                    (openBlock(), createBlock(resolveDynamicComponent(option.icon))),
                    createBaseVNode("span", _hoisted_7, toDisplayString(option.title), 1)
                  ])
                ]),
                _: 2
              }, 1032, ["onClick"]);
            }), 64))
          ]),
          _: 1
        }),
        createVNode(_component_general_social),
        createVNode(_component_general_sponsors, { nav: true })
      ])
    ]),
    default: withCtx(() => [
      createBaseVNode("div", _hoisted_8, [
        createBaseVNode("div", _hoisted_9, [
          createBaseVNode("div", _hoisted_10, toDisplayString($setup.activePage), 1),
          createBaseVNode("div", _hoisted_11, [
            createVNode($setup["MaterialSymbolsGridView"], {
              class: normalizeClass([$setup.route.name === "index-index" ? "!text-primary" : "", "cursor-pointer p-2 hover:bg-gray-300/50 rounded-full"]),
              onClick: _cache[2] || (_cache[2] = ($event) => $setup.navigateTo("/"))
            }, null, 8, ["class"]),
            createVNode($setup["MaterialSymbolsFormatListBulletedRounded"], {
              class: normalizeClass([$setup.route.name === "index-index-list" ? "!text-primary" : "", "cursor-pointer p-2 hover:bg-gray-300/50 rounded-full"]),
              onClick: _cache[3] || (_cache[3] = ($event) => $setup.navigateTo("/list"))
            }, null, 8, ["class"])
          ])
        ]),
        createVNode(_component_a_divider, { class: "!mb-4 !lg:mb-8" }),
        createVNode(_component_NuxtPage, {
          projects: $setup.projects,
          onDeleteProject: $setup.deleteProject
        }, null, 8, ["projects"])
      ]),
      createVNode(_component_a_modal)
    ]),
    _: 1
  });
}
var index = /* @__PURE__ */ _export_sfc(_sfc_main, [["render", _sfc_render]]);
export { index as default };
