import { _ as __nuxt_component_1 } from "./Sponsors-76711a53.mjs";
import { _ as __nuxt_component_1$1 } from "./SocialCard-7e699f38.mjs";
import { o as openBlock, c as createElementBlock, b as createBaseVNode, _ as _export_sfc, d as defineComponent, u as useNuxtApp, a5 as useApi, s as useUIPermission, r as ref, f as computed, x as onMounted, y as resolveDirective, l as createBlock, k as withCtx, dG as navigateTo, dH as __nuxt_component_2, j as createVNode, z as toDisplayString, H as normalizeClass, J as withDirectives, E as createTextVNode, B as createCommentVNode, dW as TransitionGroup, D as withModifiers, aa as Modal, $ as message, a2 as extractSdkResponseErrorMsg, L as pushScopeId, N as popScopeId, ah as __unplugin_components_7, dX as __unplugin_components_2, aJ as MdiMenuDown, ai as __unplugin_components_0$1, am as Menu, V as Dropdown, dY as __unplugin_components_10, c2 as __unplugin_components_3, dB as __unplugin_components_13, n as Card } from "./entry-3ffd12c8.mjs";
import { M as MdiEditOutline } from "./edit-outline-3164cf72.mjs";
import { M as MdiDatabaseOutline } from "./database-outline-41b305ba.mjs";
import { _ as __unplugin_components_4 } from "./plus-outline-d4c7c0e9.mjs";
import { u as useSidebar } from "./index-75f7d1ec.mjs";
import "./index-6b9e74a9.mjs";
import { S as Skeleton } from "./index-707d6e88.mjs";
import "./index-9b24011f.mjs";
import "./star-outline-8f5da6b4.mjs";
const _hoisted_1$1 = {
  class: "nc-icon",
  preserveAspectRatio: "xMidYMid meet",
  viewBox: "0 0 24 24",
  width: "1.2em",
  height: "1.2em"
};
const _hoisted_2$1 = /* @__PURE__ */ createBaseVNode("path", {
  fill: "currentColor",
  d: "M17.65 6.35A7.958 7.958 0 0 0 12 4a8 8 0 0 0-8 8a8 8 0 0 0 8 8c3.73 0 6.84-2.55 7.73-6h-2.08A5.99 5.99 0 0 1 12 18a6 6 0 0 1-6-6a6 6 0 0 1 6-6c1.66 0 3.14.69 4.22 1.78L13 11h7V4l-2.35 2.35Z"
}, null, -1);
const _hoisted_3$1 = [
  _hoisted_2$1
];
function render(_ctx, _cache) {
  return openBlock(), createElementBlock("svg", _hoisted_1$1, _hoisted_3$1);
}
var __unplugin_components_0 = { name: "mdi-refresh", render };
const _sfc_main = /* @__PURE__ */ defineComponent({
  __name: "index",
  setup(__props, { expose }) {
    expose();
    const { $e } = useNuxtApp();
    const { api, isLoading } = useApi();
    const { isUIAllowed } = useUIPermission();
    useSidebar({ hasSidebar: true, isOpen: true });
    const filterQuery = ref("");
    const projects = ref();
    const loadProjects = async () => {
      const response = await api.project.list({});
      projects.value = response.list;
    };
    const filteredProjects = computed(() => {
      var _a, _b;
      return (_b = (_a = projects.value) == null ? void 0 : _a.filter((project) => {
        var _a2, _b2;
        return !filterQuery.value || ((_b2 = (_a2 = project.title) == null ? void 0 : _a2.toLowerCase) == null ? void 0 : _b2.call(_a2).includes(filterQuery.value.toLowerCase()));
      })) != null ? _b : [];
    });
    const deleteProject = (project) => {
      $e("c:project:delete");
      Modal.confirm({
        title: `Do you want to delete '${project.title}' project?`,
        okText: "Yes",
        okType: "danger",
        cancelText: "No",
        async onOk() {
          var _a;
          try {
            await api.project.delete(project.id);
            $e("a:project:delete");
            return (_a = projects.value) == null ? void 0 : _a.splice(projects.value.indexOf(project), 1);
          } catch (e) {
            return message.error(await extractSdkResponseErrorMsg(e));
          }
        }
      });
    };
    onMounted(() => {
      loadProjects();
    });
    const __returned__ = { $e, api, isLoading, isUIAllowed, filterQuery, projects, loadProjects, filteredProjects, deleteProject, navigateTo };
    Object.defineProperty(__returned__, "__isScriptSetup", { enumerable: false, value: true });
    return __returned__;
  }
});
const _withScopeId = (n) => (pushScopeId("data-v-1d26bb0f"), n = n(), popScopeId(), n);
const _hoisted_1 = { class: "flex flex-col md:flex-row flex-wrap gap-6 py-6 px-12" };
const _hoisted_2 = { class: "hidden xl:block" };
const _hoisted_3 = { class: "min-w-2/4 flex-auto" };
const _hoisted_4 = { class: "flex items-center justify-center gap-2 leading-8 mb-8" };
const _hoisted_5 = { class: "text-4xl" };
const _hoisted_6 = { class: "order-1 flex mb-6" };
const _hoisted_7 = /* @__PURE__ */ _withScopeId(() => /* @__PURE__ */ createBaseVNode("div", { class: "flex-1" }, null, -1));
const _hoisted_8 = { class: "nc-new-project-menu" };
const _hoisted_9 = { class: "flex items-center w-full" };
const _hoisted_10 = ["innerHTML"];
const _hoisted_11 = { key: 0 };
const _hoisted_12 = { class: "capitalize color-transition group-hover:text-primary !w-[400px] overflow-hidden overflow-ellipsis whitespace-nowrap" };
const _hoisted_13 = { class: "flex items-center gap-2" };
const _hoisted_14 = { class: "flex gap-6 md:block" };
const _hoisted_15 = { class: "block mt-0 !md:mt-6 xl:hidden" };
function _sfc_render(_ctx, _cache, $props, $setup, $data, $options) {
  const _component_GeneralSponsors = __nuxt_component_1;
  const _component_MdiRefresh = __unplugin_components_0;
  const _component_a_tooltip = __unplugin_components_7;
  const _component_a_input_search = __unplugin_components_2;
  const _component_MdiMenuDown = MdiMenuDown;
  const _component_MdiPlusOutline = __unplugin_components_4;
  const _component_a_menu_item = __unplugin_components_0$1;
  const _component_MdiDatabaseOutline = MdiDatabaseOutline;
  const _component_a_menu = Menu;
  const _component_a_dropdown = Dropdown;
  const _component_a_skeleton = Skeleton;
  const _component_a_table_column = __unplugin_components_10;
  const _component_MdiEditOutline = MdiEditOutline;
  const _component_MdiDeleteOutline = __unplugin_components_3;
  const _component_a_table = __unplugin_components_13;
  const _component_a_card = Card;
  const _component_GeneralSocialCard = __nuxt_component_1$1;
  const _component_NuxtLayout = __nuxt_component_2;
  const _directive_t = resolveDirective("t");
  return openBlock(), createBlock(_component_NuxtLayout, null, {
    default: withCtx(() => [
      createBaseVNode("div", _hoisted_1, [
        createBaseVNode("div", _hoisted_2, [
          createVNode(_component_GeneralSponsors)
        ]),
        createBaseVNode("div", _hoisted_3, [
          createVNode(_component_a_card, { class: "transition-all duration-300 ease-out !rounded-lg shadow" }, {
            default: withCtx(() => [
              createBaseVNode("h1", _hoisted_4, [
                createBaseVNode("span", _hoisted_5, toDisplayString(_ctx.$t("title.myProject")), 1),
                createVNode(_component_a_tooltip, { title: "Reload projects" }, {
                  default: withCtx(() => [
                    createBaseVNode("span", {
                      class: normalizeClass(["transition-all duration-200 h-full flex items-center group hover:ring active:ring active:ring-accent rounded-full mt-1", $setup.isLoading ? "animate-spin ring ring-gray-200" : ""])
                    }, [
                      withDirectives(createVNode(_component_MdiRefresh, {
                        class: normalizeClass(["text-xl text-gray-500 group-hover:text-accent cursor-pointer", $setup.isLoading ? "!text-primary" : ""]),
                        onClick: $setup.loadProjects
                      }, null, 8, ["class"]), [
                        [_directive_t, ["a:project:refresh"]]
                      ])
                    ], 2)
                  ]),
                  _: 1
                })
              ]),
              createBaseVNode("div", _hoisted_6, [
                createVNode(_component_a_input_search, {
                  value: $setup.filterQuery,
                  "onUpdate:value": _cache[0] || (_cache[0] = ($event) => $setup.filterQuery = $event),
                  class: "max-w-[250px] nc-project-page-search rounded",
                  placeholder: _ctx.$t("activity.searchProject")
                }, null, 8, ["value", "placeholder"]),
                _hoisted_7,
                $setup.isUIAllowed("projectCreate", true) ? (openBlock(), createBlock(_component_a_dropdown, {
                  key: 0,
                  trigger: ["click"]
                }, {
                  overlay: withCtx(() => [
                    createVNode(_component_a_menu, { class: "!py-0 rounded" }, {
                      default: withCtx(() => [
                        createVNode(_component_a_menu_item, null, {
                          default: withCtx(() => [
                            withDirectives((openBlock(), createElementBlock("div", {
                              class: "nc-project-menu-item group",
                              onClick: _cache[1] || (_cache[1] = ($event) => $setup.navigateTo("/project/create"))
                            }, [
                              createVNode(_component_MdiPlusOutline, { class: "group-hover:text-accent" }),
                              createBaseVNode("div", null, toDisplayString(_ctx.$t("activity.createProject")), 1)
                            ])), [
                              [_directive_t, ["c:project:create:xcdb"]]
                            ])
                          ]),
                          _: 1
                        }),
                        createVNode(_component_a_menu_item, null, {
                          default: withCtx(() => [
                            withDirectives((openBlock(), createElementBlock("div", {
                              class: "nc-project-menu-item group",
                              onClick: _cache[2] || (_cache[2] = ($event) => $setup.navigateTo("/project/create-external"))
                            }, [
                              createVNode(_component_MdiDatabaseOutline, { class: "group-hover:text-accent" }),
                              createBaseVNode("div", {
                                innerHTML: _ctx.$t("activity.createProjectExtended.extDB")
                              }, null, 8, _hoisted_10)
                            ])), [
                              [_directive_t, ["c:project:create:extdb"]]
                            ])
                          ]),
                          _: 1
                        })
                      ]),
                      _: 1
                    })
                  ]),
                  default: withCtx(() => [
                    createBaseVNode("button", _hoisted_8, [
                      createBaseVNode("div", _hoisted_9, [
                        createTextVNode(toDisplayString(_ctx.$t("title.newProj")) + " ", 1),
                        createVNode(_component_MdiMenuDown, { class: "menu-icon" })
                      ])
                    ])
                  ]),
                  _: 1
                })) : createCommentVNode("", true)
              ]),
              createVNode(TransitionGroup, {
                name: "layout",
                mode: "out-in"
              }, {
                default: withCtx(() => [
                  $setup.isLoading ? (openBlock(), createElementBlock("div", _hoisted_11, [
                    createVNode(_component_a_skeleton)
                  ])) : (openBlock(), createBlock(_component_a_table, {
                    key: 1,
                    "custom-row": (record) => ({
                      onClick: () => {
                        $setup.$e("a:project:open");
                        $setup.navigateTo(`/nc/${record.id}`);
                      },
                      class: ["group"]
                    }),
                    "data-source": $setup.filteredProjects,
                    pagination: { position: ["bottomCenter"] }
                  }, {
                    default: withCtx(() => [
                      createVNode(_component_a_table_column, {
                        key: "title",
                        title: _ctx.$t("general.title"),
                        "data-index": "title"
                      }, {
                        default: withCtx(({ text }) => [
                          createBaseVNode("div", _hoisted_12, toDisplayString(text), 1)
                        ]),
                        _: 1
                      }, 8, ["title"]),
                      createVNode(_component_a_table_column, {
                        key: "id",
                        title: _ctx.$t("labels.actions"),
                        "data-index": "id"
                      }, {
                        default: withCtx(({ text, record }) => [
                          createBaseVNode("div", _hoisted_13, [
                            withDirectives(createVNode(_component_MdiEditOutline, {
                              class: "nc-action-btn",
                              onClick: withModifiers(($event) => $setup.navigateTo(`/project/${text}`), ["stop"])
                            }, null, 8, ["onClick"]), [
                              [_directive_t, ["c:project:edit:rename"]]
                            ]),
                            createVNode(_component_MdiDeleteOutline, {
                              class: "nc-action-btn",
                              onClick: withModifiers(($event) => $setup.deleteProject(record), ["stop"])
                            }, null, 8, ["onClick"])
                          ])
                        ]),
                        _: 1
                      }, 8, ["title"])
                    ]),
                    _: 1
                  }, 8, ["custom-row", "data-source"]))
                ]),
                _: 1
              })
            ]),
            _: 1
          })
        ]),
        createBaseVNode("div", _hoisted_14, [
          createVNode(_component_GeneralSocialCard),
          createBaseVNode("div", _hoisted_15, [
            createVNode(_component_GeneralSponsors)
          ])
        ])
      ])
    ]),
    _: 1
  });
}
var index = /* @__PURE__ */ _export_sfc(_sfc_main, [["render", _sfc_render], ["__scopeId", "data-v-1d26bb0f"]]);
export { index as default };
