import { d as defineComponent, b9 as useConfigInject, be as _defineProperty, bg as getPropsSlot, j as createVNode, bc as PropTypes, f as computed, n as Card } from "./entry-3ffd12c8.mjs";
var cardMetaProps = function cardMetaProps2() {
  return {
    prefixCls: String,
    title: PropTypes.any,
    description: PropTypes.any,
    avatar: PropTypes.any
  };
};
var __unplugin_components_0 = defineComponent({
  name: "ACardMeta",
  props: cardMetaProps(),
  slots: ["title", "description", "avatar"],
  setup: function setup(props, _ref) {
    var slots = _ref.slots;
    var _useConfigInject = useConfigInject("card", props), prefixCls = _useConfigInject.prefixCls;
    return function() {
      var classString = _defineProperty({}, "".concat(prefixCls.value, "-meta"), true);
      var avatar = getPropsSlot(slots, props, "avatar");
      var title = getPropsSlot(slots, props, "title");
      var description = getPropsSlot(slots, props, "description");
      var avatarDom = avatar ? createVNode("div", {
        "class": "".concat(prefixCls.value, "-meta-avatar")
      }, [avatar]) : null;
      var titleDom = title ? createVNode("div", {
        "class": "".concat(prefixCls.value, "-meta-title")
      }, [title]) : null;
      var descriptionDom = description ? createVNode("div", {
        "class": "".concat(prefixCls.value, "-meta-description")
      }, [description]) : null;
      var MetaDetail = titleDom || descriptionDom ? createVNode("div", {
        "class": "".concat(prefixCls.value, "-meta-detail")
      }, [titleDom, descriptionDom]) : null;
      return createVNode("div", {
        "class": classString
      }, [avatarDom, MetaDetail]);
    };
  }
});
var cardGridProps = function cardGridProps2() {
  return {
    prefixCls: String,
    hoverable: {
      type: Boolean,
      default: true
    }
  };
};
var Grid = defineComponent({
  name: "ACardGrid",
  __ANT_CARD_GRID: true,
  props: cardGridProps(),
  setup: function setup2(props, _ref) {
    var slots = _ref.slots;
    var _useConfigInject = useConfigInject("card", props), prefixCls = _useConfigInject.prefixCls;
    var classNames = computed(function() {
      var _ref2;
      return _ref2 = {}, _defineProperty(_ref2, "".concat(prefixCls.value, "-grid"), true), _defineProperty(_ref2, "".concat(prefixCls.value, "-grid-hoverable"), props.hoverable), _ref2;
    });
    return function() {
      var _a;
      return createVNode("div", {
        "class": classNames.value
      }, [(_a = slots.default) === null || _a === void 0 ? void 0 : _a.call(slots)]);
    };
  }
});
Card.Meta = __unplugin_components_0;
Card.Grid = Grid;
Card.install = function(app) {
  app.component(Card.name, Card);
  app.component(__unplugin_components_0.name, __unplugin_components_0);
  app.component(Grid.name, Grid);
  return app;
};
export { __unplugin_components_0 as _ };
